-- _____                 _           _    ___              _       _   _      
--/  __ \               | |         | |  / _ \            | |     | | (_)     
--| /  \/ ___  _ __ ___ | |__   __ _| |_/ /_\ \_ __   __ _| |_   _| |_ _  ___  ___ 
--| |    / _ \| '_ ` _ \| '_ \ / _` | __|  _  | '_ \ / _` | | | | | __| |/ __|/ __|
--| \__/\ (_) | | | | | | |_) | (_| | |_| | | | | | | (_| | | |_| | |_| | (__ \__ \
-- \____/\___/|_| |_| |_|_.__/ \__,_|\__\_| |_/_| |_|\__,_|_|\__, |\__|_|\___||___/
--                                                            __/ |           
--                                                           |___/
--Copyright by: ESO-EU Dero / @Deryl
--Thx to @Puse for some helpful Thoughts

-- Add-on properties
ESO_CA                               = {}
local ESO_CA                         = ESO_CA
ESO_CA.name                          = "CombatAnalytics"
ESO_CA.description                   = "CombatAnalytics"
ESO_CA.version                       = "1.0.9"
ESO_CA.savedVariablesName            = 'ESO_CA_SavedVariables'
ESO_CA.configVersion                 = 4
ESO_CA.configNamespace               = 'ESO_CA'
ESO_CA.watch = ""
ESO_CA.listening = false

local EVENT_MANAGER                 = EVENT_MANAGER

-- Function for wrong chat commands
function ESO_CA.wrongcommand(arg)
	log(arg .. " is not a valid command!")
end

-- Main function called by the /can command
function ESO_CA.Main(arg)
	ArgArray = {} --Defining an Array for the Argument
	ArgArrayNum = 1 --Count to fill the Array
	for i in string.gmatch(arg, "%S+") do
		ArgArray[ArgArrayNum] = i
		ArgArrayNum = ArgArrayNum + 1
	end
    if arg == "" or arg == "help" or arg == "hilfe" then
        log("|cffffff- |c880000CombatAnalytics |cffffff-")
		log(ESO_CA_L_HELPSHOW[ESO_CA_Lang])
		log(ESO_CA_L_HELPMAIN[ESO_CA_Lang])
		log(ESO_CA_L_HELPSTAT[ESO_CA_Lang])
		log(ESO_CA_L_HELPSETT[ESO_CA_Lang])
		log(ESO_CA_L_HELPINFO[ESO_CA_Lang])
	elseif arg == "update" then
		ESO_CA_SavedData.ConfigVersion = nil
		ESO_CA.CheckForUpdate()
	elseif arg == "sett" then
		ESO_CA.OpenSettings()
	elseif arg == "info" then
		ESO_CA.ShowInfo()
	elseif arg == "stat" then
		ESO_CA.SHOWSTAT()
	elseif arg == "main" then
		ESO_CA.ShowHideButtons()
	elseif arg == "show" then
		ESO_CA.ShowCombatAnalytics()
	elseif ArgArray[1] == "test" then
		ESO_CA.test(ArgArray[2],ArgArray[3])
	else
		ESO_CA.wrongcommand(arg)
    end
end

-- Log a message to Chat
function ESO_CA.Log(msg)
    d(msg)
end

--Fade In/Out Something
function ESO_CA.Fade(Duration,Item,StartAlp,EndAlp)
	Item:SetTopmost(true)
	if(ESO_CA_CURRENTINFOFADE ~= nil)then
		ESO_CA_CURRENTINFOFADE:Stop()
	end
	local ani, tl = CreateSimpleAnimation(ANIMATION_ALPHA , Item)
	ani:SetAlphaValues(StartAlp, EndAlp)
	ani:SetDuration(Duration)
	ani:SetEasingFunction(ZO_EaseInQuartic)
	tl:SetPlaybackType(ANIMATION_PLAYBACK_ONE_SHOT)
	tl:PlayFromStart()	
	return tl
end

-- Initialise the add-on
function ESO_CA.OnAddOnLoaded(eventCode, addOnName)
    if (addOnName ~= ESO_CA.name) then return end
    -- Unregister for loaded event
    EVENT_MANAGER:UnregisterForEvent(ESO_CA.name, EVENT_ADD_ON_LOADED)

	-- Logging for Debugging
    log = ESO_CA.Log
    dbg = ESO_CA.Debug

    -- Slash command
    SLASH_COMMANDS["/can"] = ESO_CA.Main

	--Initialize Saved data
	ESO_CA.Initdata()
	
	--Loading saved Variables and setting item to save them
	ESO_CA_SavedData = ZO_SavedVars:NewAccountWide("ESO_CA_CombatData", 1, nil, ESO_CA_DATA)
	
	--Load the Language Files
	ESO_CA.InitLanguage()
	
	--Check for Updated Version
	ESO_CA.CheckForUpdate()

	--Initiate KeyBinding
	ZO_CreateStringId("SI_BINDING_NAME_OPEN_ESOCA_MENU", ESO_CA_L_HOTKEYOPEN[ESO_CA_Lang])
	ZO_CreateStringId("SI_BINDING_NAME_SAVE_ESOCA_CURRENT_LOG", ESO_CA_L_HOTKEYSAVE[ESO_CA_Lang])
	ZO_CreateStringId("SI_BINDING_NAME_OPEN_ESOCA_SETTINGS", ESO_CA_L_HOTKEYSETTINGS[ESO_CA_Lang])
	ZO_CreateStringId("SI_BINDING_NAME_POST_ESOCA_TARGETS_TO_CHAT", ESO_CA_L_HOTKEYTARGETTOCHAT[ESO_CA_Lang])
	ZO_CreateStringId("SI_BINDING_NAME_POST_ESOCA_HIGHTARGET_TO_CHAT", ESO_CA_L_HOTKEYHIGHTARGETTOCHAT[ESO_CA_Lang])
	ZO_CreateStringId("SI_BINDING_NAME_OPEN_ESOCA_BUTTONS", ESO_CA_L_HOTKEYSHOWBTN[ESO_CA_Lang])
	ZO_CreateStringId("SI_BINDING_NAME_OPEN_ESOCA_STATISTIC", ESO_CA_L_HOTKEYSSTAT[ESO_CA_Lang])

	--Register the CombatStateChange event
	EVENT_MANAGER:RegisterForEvent("CombatStateChange", EVENT_PLAYER_COMBAT_STATE, ESO_CA.CombatState)
	
	--Register the CombatEvent event to aprse damage
	EVENT_MANAGER:RegisterForEvent("CombatEvent", EVENT_COMBAT_EVENT, ESO_CA.CombatEvents)
	
	--Registe the WeaponSwap event to update skillicons for light and Heavy attacks
	EVENT_MANAGER:RegisterForEvent("AbilitysChanged", EVENT_ABILITY_LIST_CHANGED, ESO_CA.GetAllAbilityIcons)
	
	--Open the CA list
	ESO_CA.InitCA()

	--Preload the Statistic
	ESO_CA.openstatistic()
	
	--Init Info
	ESO_CA.InitInfo()
	
	--Init Settings
	ESO_CA.InitSettings()
	
end

--function to Add Toplevelwindows to HUD Scene to Hide if another SCENE opens
function ESO_CA.AddUiFragment(NewFragment)
	local Hud = SCENE_MANAGER:GetScene("hud")
	local HudUI = SCENE_MANAGER:GetScene("hudui")
	local fragment = ZO_SimpleSceneFragment:New(NewFragment)
	Hud:AddFragment(fragment)
	HudUI:AddFragment(fragment)
	return fragment
end

--function to Remove Toplevelwindows from Scene
function ESO_CA.RemUiFragment(OldFragment)
    local Hud = SCENE_MANAGER:GetScene("hud")
	local HudUI = SCENE_MANAGER:GetScene("hudui")
	Hud:RemoveFragment(OldFragment)
	HudUI:RemoveFragment(OldFragment)
end

-- Register for the initialisation event
EVENT_MANAGER:RegisterForEvent(ESO_CA.name, EVENT_ADD_ON_LOADED, ESO_CA.OnAddOnLoaded)