-- _____                 _           _    ___              _       _   _      
--/  __ \               | |         | |  / _ \            | |     | | (_)     
--| /  \/ ___  _ __ ___ | |__   __ _| |_/ /_\ \_ __   __ _| |_   _| |_ _  ___  ___ 
--| |    / _ \| '_ ` _ \| '_ \ / _` | __|  _  | '_ \ / _` | | | | | __| |/ __|/ __|
--| \__/\ (_) | | | | | | |_) | (_| | |_| | | | | | | (_| | | |_| | |_| | (__ \__ \
-- \____/\___/|_| |_| |_|_.__/ \__,_|\__\_| |_/_| |_|\__,_|_|\__, |\__|_|\___||___/
--                                                            __/ |           
--                                                           |___/
--Copyright by: ESO-EU Dero / @Deryl
--Thx to @Puse for some helpful Thoughts

--Shows the Info (Hotkeys, Commands, etc.)
function ESO_CA.InitInfo()
	local InfoWidth = 500
	local InfoHeight = 320
	if (ESO_CA_INF == nil) then
		--Frame for Info
		local ESO_CA_INF = WINDOW_MANAGER:CreateTopLevelWindow("ESO_CA_INF")
		ESO_CA_INF:SetDrawLayer(1)
		ESO_CA_INF:SetAnchor(CENTER,GuiRoot,CENTER,0,0)
		ESO_CA_INF:SetWidth(InfoWidth)
		ESO_CA_INF:SetMouseEnabled(true)
		ESO_CA_INF:SetClampedToScreen(true)
		ESO_CA_INF:SetClampedToScreenInsets(-8,-8,6,6)
		ESO_CA_INF:SetMovable(true)
		ESO_CA_INF:SetHidden(true)
		ESO_CA_INF_BG = WINDOW_MANAGER:CreateControlFromVirtual("ESO_CA_INF_BG",ESO_CA_INF,"ESO_CA_DefaultBackdrop")
		
		--Info Header
		local ESO_CA_INF_HEADER = WINDOW_MANAGER:CreateControl("ESO_CA_INF_HEADER",ESO_CA_INF,CT_LABEL)
		ESO_CA_INF_HEADER:SetText("|c880000" .. ESO_CA.name .. " |rv." .. ESO_CA.version .. " |c888866" .. ESO_CA_L_INFO[ESO_CA_Lang])
		ESO_CA_INF_HEADER:SetFont("ZoFontGame")
		ESO_CA_INF_HEADER:SetAnchor(TOP,ESO_CA_INF,TOP,0,0)
		
		--X-Button to Close the Info
		local ESO_CA_INF_BTNCLOSE = WINDOW_MANAGER:CreateControl("ESO_CA_INF_BTNCLOSE",ESO_CA_INF,CT_BUTTON)
		ESO_CA_INF_BTNCLOSE:SetDimensions(20,20)
		ESO_CA_INF_BTNCLOSE:SetHandler("OnClicked",function() ESO_CA_INF:SetHidden(true) end)
		ESO_CA_INF_BTNCLOSE:SetNormalTexture("ESOUI/art/buttons/decline_up.dds")
		ESO_CA_INF_BTNCLOSE:SetMouseOverTexture("ESOUI/art/buttons/decline_over.dds")
		ESO_CA_INF_BTNCLOSE:SetAnchor(TOPRIGHT,ESO_CA_INF,TOPRIGHT,0,0)
		
		--Line00
		local ESO_CA_INF_LINE00 = WINDOW_MANAGER:CreateControl("ESO_CA_INF_LINE00",ESO_CA_INF,CT_TEXTURE)
		ESO_CA_INF_LINE00:SetDimensions(InfoWidth,2)
		ESO_CA_INF_LINE00:SetAnchor(TOPLEFT,ESO_CA_INF,TOPLEFT,0,25)
		ESO_CA_INF_LINE00:SetTexture("/esoui/art/progression/ability_line.dds")
		
		--HowTo Container
		local ESO_CA_INF_HOWCONT = WINDOW_MANAGER:CreateControl("ESO_CA_INF_HOWCONT",ESO_CA_INF,CT_CONTROL)
		ESO_CA_INF_HOWCONT:SetDimensions(InfoWidth,85)
		ESO_CA_INF_HOWCONT:SetMovable(true)
		ESO_CA_INF_HOWCONT:SetMouseEnabled(true)
		ESO_CA_INF_HOWCONT:SetClampedToScreen(true)
		ESO_CA_INF_HOWCONT:SetClampedToScreenInsets(-8,-8,6,6)
		ESO_CA_INF_HOWCONT:SetAnchor(TOPLEFT,ESO_CA_INF,TOPRIGHT,0,0)
		ESO_CA_INF_HOWCONT:SetHidden(true)
		ESO_CA_INF_HOWCONT_BG = WINDOW_MANAGER:CreateControlFromVirtual("ESO_CA_INF_HOWCONT_BG",ESO_CA_INF_HOWCONT,"ESO_CA_DefaultBackdrop")

		--HowTo Header
		local ESO_CA_INF_HOWH = WINDOW_MANAGER:CreateControl("ESO_CA_INF_HOWH",ESO_CA_INF_HOWCONT,CT_LABEL)
		ESO_CA_INF_HOWH:SetFont("ZoFontTooltipTitle")
		ESO_CA_INF_HOWH:SetAnchor(TOP,ESO_CA_INF_HOWCONT,TOP,0,10)
		
		--HowTo Image
		local ESO_CA_INF_HOWIMG = WINDOW_MANAGER:CreateControl("ESO_CA_INF_HOWIMG",ESO_CA_INF_HOWCONT,CT_TEXTURE)
		ESO_CA_INF_HOWIMG:SetDimensions(256,128)
		ESO_CA_INF_HOWIMG:SetAnchor(TOP,ESO_CA_INF_HOWH,BOTTOM,0,10)
		
		--HowTo Text
		local ESO_CA_INF_HOWTXT = WINDOW_MANAGER:CreateControl("ESO_CA_INF_HOWTXT",ESO_CA_INF_HOWCONT,CT_LABEL)
		ESO_CA_INF_HOWTXT:SetFont("ZoFontGame")
		ESO_CA_INF_HOWTXT:SetWidth(InfoWidth-10)
		ESO_CA_INF_HOWTXT:SetHorizontalAlignment(3)
		ESO_CA_INF_HOWTXT:SetAnchor(TOP,ESO_CA_INF_HOWIMG,BOTTOM,0,10)
		
		--Button Back
		local ESO_CA_INF_HOWBTNBACK = WINDOW_MANAGER:CreateControl("ESO_CA_INF_HOWBTNBACK",ESO_CA_INF_HOWCONT,CT_BUTTON)
		ESO_CA_INF_HOWBTNBACK:SetDimensions(125,25)
		ESO_CA_INF_HOWBTNBACK:SetAnchor(TOP,ESO_CA_INF_HOWTXT,BOTTOM,0,10)
		ESO_CA_INF_HOWBTNBACK:SetFont("ZoFontGame")
		ESO_CA_INF_HOWBTNBACK:SetText("|c888866" .. ESO_CA_L_BACK[ESO_CA_Lang])
		ESO_CA_INF_HOWBTNBACK:SetNormalTexture(NormButton[1])
		ESO_CA_INF_HOWBTNBACK:SetMouseOverTexture(NormButton[2])
		ESO_CA_INF_HOWBTNBACK:SetHandler("OnClicked",function() ESO_CA_INF_HOWCONT:SetHidden(true) end)
		
		--HowTo's Container
		local ESO_CA_INF_HOWSCONT = WINDOW_MANAGER:CreateControl("ESO_CA_INF_HOWSCONT",ESO_CA_INF,CT_CONTROL)
		ESO_CA_INF_HOWSCONT:SetWidth(InfoWidth-10)
		ESO_CA_INF_HOWSCONT:SetAnchor(TOPLEFT,ESO_CA_INF_LINE00,TOPLEFT,5,5)
		
		--HowTo's Header
		local ESO_CA_INF_HOWSH = WINDOW_MANAGER:CreateControl("ESO_CA_INF_HOWSH",ESO_CA_INF_HOWSCONT,CT_LABEL)
		ESO_CA_INF_HOWSH:SetText("|c880000" .. ESO_CA_L_HOWTO[ESO_CA_Lang] .. "|r:")
		ESO_CA_INF_HOWSH:SetFont("ZoFontTooltipTitle")
		ESO_CA_INF_HOWSH:SetAnchor(TOPLEFT,ESO_CA_INF_HOWSCONT,TOPLEFT,0,0)
		
		--Button Window Anchoring
		local ESO_CA_INF_HOWSBTNANC = WINDOW_MANAGER:CreateControl("ESO_CA_INF_HOWSBTNANC",ESO_CA_INF_HOWSCONT,CT_BUTTON)
		ESO_CA_INF_HOWSBTNANC:SetDimensions((InfoWidth-20)/2,20)
		ESO_CA_INF_HOWSBTNANC:SetAnchor(TOPLEFT,ESO_CA_INF_HOWSH,BOTTOMLEFT,0,10)
		ESO_CA_INF_HOWSBTNANC:SetFont("ZoFontGame")
		ESO_CA_INF_HOWSBTNANC:SetText("|c888866" .. ESO_CA_L_WANCHORING[ESO_CA_Lang][1])
		ESO_CA_INF_HOWSBTNANC:SetNormalTexture(NormButton[1])
		ESO_CA_INF_HOWSBTNANC:SetMouseOverTexture(NormButton[2])
		ESO_CA_INF_HOWSBTNANC:SetHandler("OnClicked",function() ESO_CA.SetHowTo(ESO_CA_L_WANCHORING[ESO_CA_Lang][1],ESO_CA_L_WANCHORING[ESO_CA_Lang][2],ESO_CA_L_WANCHORING[ESO_CA_Lang][3]) end)
		
		--Button Window Settings
		local ESO_CA_INF_HOWSBTNWSE = WINDOW_MANAGER:CreateControl("ESO_CA_INF_HOWSBTNWSE",ESO_CA_INF_HOWSCONT,CT_BUTTON)
		ESO_CA_INF_HOWSBTNWSE:SetDimensions((InfoWidth-20)/2,20)
		ESO_CA_INF_HOWSBTNWSE:SetAnchor(TOPLEFT,ESO_CA_INF_HOWSBTNANC,TOPRIGHT,10,0)
		ESO_CA_INF_HOWSBTNWSE:SetFont("ZoFontGame")
		ESO_CA_INF_HOWSBTNWSE:SetText("|c888866" .. ESO_CA_L_WSETTING[ESO_CA_Lang][1])
		ESO_CA_INF_HOWSBTNWSE:SetNormalTexture(NormButton[1])
		ESO_CA_INF_HOWSBTNWSE:SetMouseOverTexture(NormButton[2])
		ESO_CA_INF_HOWSBTNWSE:SetHandler("OnClicked",function() ESO_CA.SetHowTo(ESO_CA_L_WSETTING[ESO_CA_Lang][1],ESO_CA_L_WSETTING[ESO_CA_Lang][2],ESO_CA_L_WSETTING[ESO_CA_Lang][3]) end)

		--Button Window Settings 2
		local ESO_CA_INF_HOWSBTNWSE2 = WINDOW_MANAGER:CreateControl("ESO_CA_INF_HOWSBTNWSE2",ESO_CA_INF_HOWSCONT,CT_BUTTON)
		ESO_CA_INF_HOWSBTNWSE2:SetDimensions((InfoWidth-20)/2,20)
		ESO_CA_INF_HOWSBTNWSE2:SetAnchor(TOPLEFT,ESO_CA_INF_HOWSBTNANC,BOTTOMLEFT,0,10)
		ESO_CA_INF_HOWSBTNWSE2:SetFont("ZoFontGame")
		ESO_CA_INF_HOWSBTNWSE2:SetText("|c888866" .. ESO_CA_L_WSETTING2[ESO_CA_Lang][1])
		ESO_CA_INF_HOWSBTNWSE2:SetNormalTexture(NormButton[1])
		ESO_CA_INF_HOWSBTNWSE2:SetMouseOverTexture(NormButton[2])
		ESO_CA_INF_HOWSBTNWSE2:SetHandler("OnClicked",function() ESO_CA.SetHowTo(ESO_CA_L_WSETTING2[ESO_CA_Lang][1],ESO_CA_L_WSETTING2[ESO_CA_Lang][2],ESO_CA_L_WSETTING2[ESO_CA_Lang][3]) end)
		
		ESO_CA_INF_HOWSCONT:SetHeight(ESO_CA_INF_HOWSH:GetTextHeight() + 70)
		
		--Wall of Fame Container
		local ESO_CA_INF_WOFCONT = WINDOW_MANAGER:CreateControl("ESO_CA_INF_WOFCONT",ESO_CA_INF,CT_CONTROL)
		ESO_CA_INF_WOFCONT:SetWidth(InfoWidth-10)
		ESO_CA_INF_WOFCONT:SetAnchor(TOPLEFT,ESO_CA_INF_HOWSCONT,BOTTOMLEFT,0,5)
		
		--Wall of Fame Header
		local ESO_CA_INF_WOFH = WINDOW_MANAGER:CreateControl("ESO_CA_INF_WOFH",ESO_CA_INF_WOFCONT,CT_LABEL)
		ESO_CA_INF_WOFH:SetText("|c880000" .. ESO_CA_L_WOF[ESO_CA_Lang] .. "|r:")
		ESO_CA_INF_WOFH:SetFont("ZoFontTooltipTitle")
		ESO_CA_INF_WOFH:SetAnchor(TOPLEFT,ESO_CA_INF_WOFCONT,TOPLEFT,0,0)

		--Wall of Fame Header Subtext
		local ESO_CA_INF_WOFHST = WINDOW_MANAGER:CreateControl("ESO_CA_INF_WOFHST",ESO_CA_INF_WOFCONT,CT_LABEL)
		ESO_CA_INF_WOFHST:SetText("|c888866" .. ESO_CA_L_WOFTHANKS[ESO_CA_Lang])
		ESO_CA_INF_WOFHST:SetDimensions(InfoWidth-10,70)
		ESO_CA_INF_WOFHST:SetFont("ZoFontGame")
		ESO_CA_INF_WOFHST:SetAnchor(TOPLEFT,ESO_CA_INF_WOFH,BOTTOMLEFT,0,10)
		
		--Wall of Fame Scroll Donators
		local ESO_CA_INF_WOFSD = WINDOW_MANAGER:CreateControlFromVirtual("ESO_CA_INF_WOFSD", ESO_CA_INF_WOFCONT, "ZO_ScrollList")
		ESO_CA_INF_WOFSD:SetAnchor(TOPLEFT,ESO_CA_INF_WOFHST,BOTTOMLEFT,0,30)
		ESO_CA_INF_WOFSD:SetDimensions(InfoWidth-10,100)
		ESO_CA_INF_WOFSD_BG = WINDOW_MANAGER:CreateControlFromVirtual("ESO_CA_INF_WOFSD_BG",ESO_CA_INF_WOFSD,"ESO_CA_DefaultBackdrop")
		ZO_ScrollAreaBarBehavior_OnEffectivelyShown(ESO_CA_INF_WOFSD)
		ZO_ScrollList_SetUseFadeGradient(ESO_CA_INF_WOFSD,true)
		
		--Wall of Fame Donator Text
		local ESO_CA_INF_WOFDH = WINDOW_MANAGER:CreateControl("ESO_CA_INF_WOFDH",ESO_CA_INF_WOFCONT,CT_LABEL)
		ESO_CA_INF_WOFDH:SetText("|c888866" .. ESO_CA_L_WOFD[ESO_CA_Lang] .. "|r:")
		ESO_CA_INF_WOFDH:SetFont("ZoFontGame")
		ESO_CA_INF_WOFDH:SetAnchor(BOTTOMLEFT,ESO_CA_INF_WOFSD,TOPLEFT,0,0)
		
		--Data for Wall of Fame Donators
		ZO_ScrollList_AddDataType(ESO_CA_INF_WOFSD, 1 , "OneLineTextList", 20,  ESO_CA.SetWOFItem)
		WOFDonators = ZO_ScrollList_GetDataList(ESO_CA_INF_WOFSD)
		
		--WOF Donators Array
		local WOFDonator = {"1: |c880000syndicated|r - |c888866ESOUI.com Forum User |r- Wow, great stuff and can't wait to see what you have planned....",
		"2: |c840000Zong Han Ho|r - |c888866Unknown",
		"3: |c800000Tarulis |r - |c888866Unknown |r- Sehr schönes Tool. Daher hier eine kleine Spende als Dankeschön. Es hilft mir immer wieder im Spiel."}
		for i = 1 , table.getn(WOFDonator) , 1 do
			WOFDonators[i] = ZO_ScrollList_CreateDataEntry( 1, {Name = WOFDonator[i]})
		end
		ZO_ScrollList_Commit(ESO_CA_INF_WOFSD)
		
		--Wall of Fame Scroll Testers
		local ESO_CA_INF_WOFST = WINDOW_MANAGER:CreateControlFromVirtual("ESO_CA_INF_WOFST", ESO_CA_INF_WOFCONT, "ZO_ScrollList")
		ESO_CA_INF_WOFST:SetAnchor(TOPLEFT,ESO_CA_INF_WOFSD,BOTTOMLEFT,0,30)
		ESO_CA_INF_WOFST:SetDimensions(InfoWidth-10,100)
		ESO_CA_INF_WOFST_BG = WINDOW_MANAGER:CreateControlFromVirtual("ESO_CA_INF_WOFST_BG",ESO_CA_INF_WOFST,"ESO_CA_DefaultBackdrop")
		ZO_ScrollAreaBarBehavior_OnEffectivelyShown(ESO_CA_INF_WOFST)
		ZO_ScrollList_SetUseFadeGradient(ESO_CA_INF_WOFST,true)
		
		--Wall of Fame Testers Text
		local ESO_CA_INF_WOFTH = WINDOW_MANAGER:CreateControl("ESO_CA_INF_WOFTH",ESO_CA_INF_WOFCONT,CT_LABEL)
		ESO_CA_INF_WOFTH:SetText("|c888866" .. ESO_CA_L_WOFT[ESO_CA_Lang] .. "|r:")
		ESO_CA_INF_WOFTH:SetFont("ZoFontGame")
		ESO_CA_INF_WOFTH:SetAnchor(BOTTOMLEFT,ESO_CA_INF_WOFST,TOPLEFT,0,0)
		
		--Data for Wall of Fame testers
		ZO_ScrollList_AddDataType(ESO_CA_INF_WOFST, 1 , "OneLineTextList", 20,  ESO_CA.SetWOFItem)
		WOFTesters = ZO_ScrollList_GetDataList(ESO_CA_INF_WOFST)
		
		--WOF Donators Array
		local WOFTester = {"|c880000Puseidr / @Puse|r - |c888866ESO-EU Server","|c880000You Don't Know Me|r - |c888866Guild on ESO-EU Server|r - www.ydkm.de"}
		for i = 1 , table.getn(WOFTester) , 1 do
			WOFTesters[i] = ZO_ScrollList_CreateDataEntry( 1, {Name = WOFTester[i]})
		end
		ZO_ScrollList_Commit(ESO_CA_INF_WOFST)
		
		ESO_CA_INF_WOFCONT:SetHeight(ESO_CA_INF_WOFH:GetTextHeight() + ESO_CA_INF_WOFHST:GetTextHeight() + ESO_CA_INF_WOFSD:GetHeight() + ESO_CA_INF_WOFST:GetHeight() + 60)
		
		ESO_CA_INF:SetHeight(ESO_CA_INF_HOWSCONT:GetHeight() + ESO_CA_INF_WOFCONT:GetHeight() + 60)
	end
end

--function to show/hide Info
function ESO_CA.ShowInfo()
	if(ESO_CA_INF:IsHidden() == true)then
		ESO_CA_INF:SetHidden(false)
	else
		ESO_CA_INF:SetHidden(true)
	end
end

--function to Fill the WOF
function ESO_CA.SetWOFItem(control,data)
	local Scroll = control:GetNamedChild("TextScroll")
	Scroll:SetDimensions(control:GetWidth(),20)
	--local a,b,c,d,e,f = Scroll:GetAnchor()
	--Scroll:SetAnchor(b,c,d,e+10,f)
	local Text = Scroll:GetNamedChild("Text")
	Text:SetText(data.Name)
	local Hover = control:GetNamedChild("Hover")
	Hover:SetDimensions(control:GetWidth(),20)
	Hover:SetTexture("none")
	control:SetHeight(20)
	control:SetHandler("OnMouseEnter",function()
		local AniEnd = Text:GetTextWidth() - Scroll:GetWidth()
		if(AniEnd > 0)then
			Scroll.tl = ESO_CA.AddTextScroll(10*AniEnd,Scroll,AniEnd)			
		end
		Hover:SetTexture("esoui/art/buttons/generic_highlight.dds")
		--log("TextWidth: " .. Text:GetTextWidth() .. " ContainerWidth: " .. Scroll:GetWidth() .. " Difference: " .. AniEnd)
	end)
	control:SetHandler("OnMouseExit",function() if(Scroll.tl ~= nil)then Scroll.tl:Stop() end Scroll:SetHorizontalScroll(0) Hover:SetTexture("none") end)
end

--function to set the HowTo Header, Img and text
function ESO_CA.SetHowTo(Header,Image,Text)
	ESO_CA_INF_HOWH:SetText("- |c880000" .. Header .. "|r -")
	ESO_CA_INF_HOWIMG:SetTexture(Image)
	ESO_CA_INF_HOWTXT:SetText("|c888866" .. Text)
	local HeaderHeight = ESO_CA_INF_HOWH:GetTextHeight()
	local ImgHeight = ESO_CA_INF_HOWIMG:GetHeight()
	local TxtHeight = ESO_CA_INF_HOWTXT:GetTextHeight()
	local BtnHeight = ESO_CA_INF_HOWBTNBACK:GetHeight()
	ESO_CA_INF_HOWCONT:SetHeight(HeaderHeight + ImgHeight + TxtHeight + BtnHeight + 50)
	ESO_CA_INF_HOWCONT:SetHidden(false)
end