-- _____                 _           _    ___              _       _   _      
--/  __ \               | |         | |  / _ \            | |     | | (_)     
--| /  \/ ___  _ __ ___ | |__   __ _| |_/ /_\ \_ __   __ _| |_   _| |_ _  ___  ___ 
--| |    / _ \| '_ ` _ \| '_ \ / _` | __|  _  | '_ \ / _` | | | | | __| |/ __|/ __|
--| \__/\ (_) | | | | | | |_) | (_| | |_| | | | | | | (_| | | |_| | |_| | (__ \__ \
-- \____/\___/|_| |_| |_|_.__/ \__,_|\__\_| |_/_| |_|\__,_|_|\__, |\__|_|\___||___/
--                                                            __/ |           
--                                                           |___/
--Copyright by: ESO-EU Dero / @Deryl
--Thx to @Puse for some helpful Thoughts

--function to Put a Log into the TempLog
function ESO_CA.SaveTempLog()
	if(ESO_CA_TIMEINCOMBAT > 0 and ESO_CA_TOTALDAMAGE > 0 and ESO_CA_TOTALHITS > 0)then
		-- Remove the last entry in the TempLogArray if its bigger than MaxNumTempLogs
		if(table.getn(TempLogArray) >= ESO_CA_SavedData.MaxNumTempLogs)then
			table.remove(TempLogArray) 
		end
		--Generate the NewTempLog Array
		local NewTempLog = {}
		
		--Put the Variables and the Arrays into the NewTempLog Array 
		local StartYearString = string.sub(ESO_CA_EndDate,1,4)
		local StartMonthString = string.sub(ESO_CA_EndDate,5,6)
		local StartDayString = string.sub(ESO_CA_EndDate,7,8)
		local NewLogName = StartDayString .. "-" .. StartMonthString .. "-" .. StartYearString .. " " .. ESO_CA_StartTime .. " - " .. ESO_CA_EndTime
		local Date = StartDayString .. "-" .. StartMonthString .. "-" .. StartYearString
		NewTempLog["StartDate"] = ESO_CA_StartDate
		NewTempLog["StartTime"] = ESO_CA_StartTime
		NewTempLog["LogName"] = NewLogName
		--Variables
		NewTempLog["EndDate"] = ESO_CA_EndDate
		NewTempLog["EndTime"] = ESO_CA_EndTime
		NewTempLog["TimeIC"] = ESO_CA_TIMEINCOMBAT
		NewTempLog["TimeBF"] = ESO_CA_TIMEUNTILFIGHT
		NewTempLog["TimeIF"] = ESO_CA_TIMEINFIGHT
		NewTempLog["TimeAF"] = ESO_CA_TIMEAFTERFIGHT
		NewTempLog["DMGT"] = ESO_CA_TOTALDAMAGE
		NewTempLog["DMGC"] = ESO_CA_TOTALCRITDAMAGE
		NewTempLog["HITT"] = ESO_CA_TOTALHITS
		NewTempLog["HITC"] = ESO_CA_TOTALCRITHITS
		NewTempLog["HITTHEAL"] = ESO_CA_TOTALHITSHEAL
		NewTempLog["HITCHEAL"] = ESO_CA_TOTALCRITHITSHEAL
		NewTempLog["HIGHESTDAMAGE"] = ESO_CA_HIGHESTDAMAGE
		NewTempLog["STARTTIME"] = ESO_CA_STARTTIME
		NewTempLog["HEALT"] = ESO_CA_TOTALHEAL
		NewTempLog["HEALC"] = ESO_CA_TOTALCRITHEAL
		--Tables
		DamageListInTable = {} -- Damage In
		for k, j in pairs(DamageListIn) do
			DamageListInTable[k] = {["SkillIcon"] = j.data["SkillIcon"], ["SkillName"] = j.data["SkillName"], ["Damage"] = j.data["Damage"], ["DamageType"] = j.data["DamageType"], ["HitCount"] = j.data["HitCount"] , ["CritHitCount"] = j.data["CritHitCount"], ["CritDamage"] = j.data["CritDamage"], ["TimeStamp"] = j.data["TimeStamp"], ["TimeString"] = j.data["TimeString"], ["ListType"] = j.data["ListType"], ["DateString"] = j.data["DateString"], ["Source"] = j.data["Source"], ["HitType"] = j.data["HitType"]}
		end
		NewTempLog["DMGListIn"] = DamageListInTable
		
		DamageListOutTable = {} -- Damage Out
		for k, j in pairs(DamageListOut) do
			DamageListOutTable[k] = {["SkillIcon"] = j.data["SkillIcon"], ["SkillName"] = j.data["SkillName"], ["Damage"] = j.data["Damage"], ["DamageType"] = j.data["DamageType"], ["HitCount"] = j.data["HitCount"] , ["CritHitCount"] = j.data["CritHitCount"], ["CritDamage"] = j.data["CritDamage"], ["TimeStamp"] = j.data["TimeStamp"], ["TimeString"] = j.data["TimeString"], ["ListType"] = j.data["ListType"], ["DateString"] = j.data["DateString"], ["Target"] = j.data["Target"]}
		end
		NewTempLog["DMGListOut"] = DamageListOutTable
		
		DamageListOutSkillTable = {} -- Damage Out Skill
		for k, j in pairs(DamageListOutSkill) do
			DamageListOutSkillTable[k] = {["SkillIcon"] = j.data["SkillIcon"], ["SkillName"] = j.data["SkillName"], ["Damage"] = j.data["Damage"], ["DamageType"] = j.data["DamageType"], ["HitCount"] = j.data["HitCount"] , ["CritHitCount"] = j.data["CritHitCount"], ["CritDamage"] = j.data["CritDamage"], ["TimeStamp"] = j.data["TimeStamp"], ["TimeString"] = j.data["TimeString"], ["ListType"] = j.data["ListType"], ["DateString"] = j.data["DateString"]}
		end
		NewTempLog["DMGListSkill"] = DamageListOutSkillTable
		
		TargetListTable = {} -- Target List
		for k, j in pairs(TargetList) do
			TargetListTable[k] = {["Damage"] = j.data["Damage"], ["HitCount"] = j.data["HitCount"] , ["CritHitCount"] = j.data["CritHitCount"], ["TargetName"] = j.data["TargetName"], ["FirstTime"] = j.data["FirstTime"] , ["LastTime"] = j.data["LastTime"]}
		end
		NewTempLog["TargetList"] = TargetListTable
				
		NewTempLog["DPSARRAY"] = ESO_CA_DPSARRAY
		
		HealListInTable = {} -- Heal In
		for k, j in pairs(IHealList) do
			HealListInTable[k] = {["SkillIcon"] = j.data["SkillIcon"], ["SkillName"] = j.data["SkillName"], ["Damage"] = j.data["Damage"], ["DamageType"] = j.data["DamageType"], ["HitCount"] = j.data["HitCount"] , ["CritHitCount"] = j.data["CritHitCount"], ["CritDamage"] = j.data["CritDamage"], ["TimeStamp"] = j.data["TimeStamp"], ["TimeString"] = j.data["TimeString"], ["ListType"] = j.data["ListType"], ["DateString"] = j.data["DateString"], ["Source"] = j.data["Source"]}
		end
		NewTempLog["IHealList"] = HealListInTable
		
		HealListOutTable = {} -- Heal Out
		for k, j in pairs(OHealList) do
			HealListOutTable[k] = {["SkillIcon"] = j.data["SkillIcon"], ["SkillName"] = j.data["SkillName"], ["Damage"] = j.data["Damage"], ["DamageType"] = j.data["DamageType"], ["HitCount"] = j.data["HitCount"] , ["CritHitCount"] = j.data["CritHitCount"], ["CritDamage"] = j.data["CritDamage"], ["TimeStamp"] = j.data["TimeStamp"], ["TimeString"] = j.data["TimeString"], ["ListType"] = j.data["ListType"], ["DateString"] = j.data["DateString"], ["Target"] = j.data["Target"]}
		end
		NewTempLog["OHealList"] = HealListOutTable
        
		HealListOutSkillTable = {} -- Heal Out Skill
		for k, j in pairs(HealListOutSkill) do
			HealListOutSkillTable[k] = {["SkillIcon"] = j.data["SkillIcon"], ["SkillName"] = j.data["SkillName"], ["Damage"] = j.data["Damage"], ["DamageType"] = j.data["DamageType"], ["HitCount"] = j.data["HitCount"] , ["CritHitCount"] = j.data["CritHitCount"], ["CritDamage"] = j.data["CritDamage"], ["TimeStamp"] = j.data["TimeStamp"], ["TimeString"] = j.data["TimeString"], ["ListType"] = j.data["ListType"], ["DateString"] = j.data["DateString"]}
		end
		NewTempLog["HealListSkill"] = HealListOutSkillTable
		--Put the new Entry in the TempLogArray
		table.insert(TempLogArray, 1, NewTempLog)
		ESO_CA_CurrentTempLog = 1
		--Update the TempLog x of y Text
		ESO_CA_HISTXOFY:SetText(ESO_CA_CurrentTempLog .. " / " .. table.getn(TempLogArray))
		ESO_CA_HISTNAME:SetText(Date .. " " .. ESO_CA_EndTime)
	end
	collectgarbage()
end

--function to cycle through TempLogs
function ESO_CA.ChangeTempLog(CurrentTempLog,NextLog)
	if(table.getn(TempLogArray) > 0 and ESO_CA_INCOMBAT ~= true)then
		if(NextLog == true)then
			CurrentTempLog = CurrentTempLog + 1
		elseif(NextLog == false)then
			CurrentTempLog = CurrentTempLog - 1
		end
		if(CurrentTempLog > table.getn(TempLogArray))then
			CurrentTempLog = 1
		elseif(CurrentTempLog < 1)then
			CurrentTempLog = table.getn(TempLogArray)
		end
		--ESO_CA.LoadTempLog(CurrentTempLog)
		ESO_CA.LOADLOG(CurrentTempLog,false)
		ESO_CA_CurrentTempLog = CurrentTempLog
		--Update the TempLog x of y Text
		ESO_CA_HISTXOFY:SetText(ESO_CA_CurrentTempLog .. " / " .. table.getn(TempLogArray))
	end
end

--function to save the current Log
function ESO_CA.SAVELOG()
	local StartYearString = string.sub(ESO_CA_EndDate,1,4)
	local StartMonthString = string.sub(ESO_CA_EndDate,5,6)
	local StartDayString = string.sub(ESO_CA_EndDate,7,8)
	local Date = StartDayString .. "-" .. StartMonthString .. "-" .. StartYearString
	local NewLogName = Date .. " " .. ESO_CA_StartTime .. " - " .. ESO_CA_EndTime
	
	local UpdateLog = false
	local UpdateLogNum = 0
	local SaveTheLog = true
	local text = ""
	
	if(ESO_CA_INCOMBAT ~= true)then
		if(ESO_CA_TIMEINCOMBAT > 0 and ESO_CA_TOTALDAMAGE > 0 and ESO_CA_TOTALHITS > 0)then
			for i = 1 , table.getn(ESO_CA_SavedData.SavedLogs) , 1 do
				if(ESO_CA_SavedData.SavedLogs[i]["LogName"] == NewLogName)then
					if(ESO_CA_SavedData.SavedLogs[i]["LogNameU"] ~= ESO_CA_HISTNAME:GetText() and ESO_CA_HISTNAME:GetText() ~= Date .. " " .. ESO_CA_SavedData.SavedLogs[i]["EndTime"])then
						UpdateLog = true						
					end
					UpdateLogNum = i
					SaveTheLog = false
					break
				end
			end
			
			if(SaveTheLog == true)then
				NewLogNumber = table.getn(ESO_CA_SavedData.SavedLogs) + 1
				ESO_CA_SavedData.SavedLogs[NewLogNumber] = {}
				--LogName
				if(ESO_CA_HISTNAME:GetText() == "" or ESO_CA_HISTNAME:GetText() == Date .. " " .. ESO_CA_EndTime)then
					ESO_CA_SavedData.SavedLogs[NewLogNumber]["LogNameU"] = ""
				else
					ESO_CA_SavedData.SavedLogs[NewLogNumber]["LogNameU"] = ESO_CA_HISTNAME:GetText()
				end
				ESO_CA_SavedData.SavedLogs[NewLogNumber]["LogName"] = NewLogName -- Default Log Name
				--Variables
				ESO_CA_SavedData.SavedLogs[NewLogNumber]["StartDate"] = ESO_CA_StartDate
				ESO_CA_SavedData.SavedLogs[NewLogNumber]["StartTime"] = ESO_CA_StartTime
				ESO_CA_SavedData.SavedLogs[NewLogNumber]["EndDate"] = ESO_CA_EndDate
				ESO_CA_SavedData.SavedLogs[NewLogNumber]["EndTime"] = ESO_CA_EndTime
				ESO_CA_SavedData.SavedLogs[NewLogNumber]["TimeIC"] = ESO_CA_TIMEINCOMBAT
				ESO_CA_SavedData.SavedLogs[NewLogNumber]["TimeBF"] = ESO_CA_TIMEUNTILFIGHT
				ESO_CA_SavedData.SavedLogs[NewLogNumber]["TimeIF"] = ESO_CA_TIMEINFIGHT
				ESO_CA_SavedData.SavedLogs[NewLogNumber]["TimeAF"] = ESO_CA_TIMEAFTERFIGHT
				ESO_CA_SavedData.SavedLogs[NewLogNumber]["DMGT"] = ESO_CA_TOTALDAMAGE
				ESO_CA_SavedData.SavedLogs[NewLogNumber]["DMGC"] = ESO_CA_TOTALCRITDAMAGE
				ESO_CA_SavedData.SavedLogs[NewLogNumber]["HITT"] = ESO_CA_TOTALHITS
				ESO_CA_SavedData.SavedLogs[NewLogNumber]["HITC"] = ESO_CA_TOTALCRITHITS
				ESO_CA_SavedData.SavedLogs[NewLogNumber]["HITTHEAL"] = ESO_CA_TOTALHITSHEAL
				ESO_CA_SavedData.SavedLogs[NewLogNumber]["HITCHEAL"] = ESO_CA_TOTALCRITHITSHEAL
				ESO_CA_SavedData.SavedLogs[NewLogNumber]["HIGHESTDAMAGE"] = ESO_CA_HIGHESTDAMAGE
				ESO_CA_SavedData.SavedLogs[NewLogNumber]["STARTTIME"] = ESO_CA_STARTTIME
				ESO_CA_SavedData.SavedLogs[NewLogNumber]["HEALT"] = ESO_CA_TOTALHEAL
				ESO_CA_SavedData.SavedLogs[NewLogNumber]["HEALC"] = ESO_CA_TOTALCRITHEAL
				--Tables
				DamageListInTable = {} -- Damage In
				for k, j in pairs(DamageListIn) do
					DamageListInTable[k] = {["SkillIcon"] = j.data["SkillIcon"], ["SkillName"] = j.data["SkillName"], ["Damage"] = j.data["Damage"], ["DamageType"] = j.data["DamageType"], ["HitCount"] = j.data["HitCount"] , ["CritHitCount"] = j.data["CritHitCount"], ["CritDamage"] = j.data["CritDamage"], ["TimeStamp"] = j.data["TimeStamp"], ["TimeString"] = j.data["TimeString"], ["ListType"] = j.data["ListType"], ["DateString"] = j.data["DateString"], ["Source"] = j.data["Source"], ["HitType"] = j.data["HitType"]}
				end
				ESO_CA_SavedData.SavedLogs[NewLogNumber]["DMGListIn"] = DamageListInTable
				
				DamageListOutTable = {} -- Damage Out
				for k, j in pairs(DamageListOut) do
					DamageListOutTable[k] = {["SkillIcon"] = j.data["SkillIcon"], ["SkillName"] = j.data["SkillName"], ["Damage"] = j.data["Damage"], ["DamageType"] = j.data["DamageType"], ["HitCount"] = j.data["HitCount"] , ["CritHitCount"] = j.data["CritHitCount"], ["CritDamage"] = j.data["CritDamage"], ["TimeStamp"] = j.data["TimeStamp"], ["TimeString"] = j.data["TimeString"], ["ListType"] = j.data["ListType"], ["DateString"] = j.data["DateString"], ["Target"] = j.data["Target"]}
				end
				ESO_CA_SavedData.SavedLogs[NewLogNumber]["DMGListOut"] = DamageListOutTable

				DamageListOutSkillTable = {} -- Damage Out Skill
				for k, j in pairs(DamageListOutSkill) do
					DamageListOutSkillTable[k] = {["SkillIcon"] = j.data["SkillIcon"], ["SkillName"] = j.data["SkillName"], ["Damage"] = j.data["Damage"], ["DamageType"] = j.data["DamageType"], ["HitCount"] = j.data["HitCount"] , ["CritHitCount"] = j.data["CritHitCount"], ["CritDamage"] = j.data["CritDamage"], ["TimeStamp"] = j.data["TimeStamp"], ["TimeString"] = j.data["TimeString"], ["ListType"] = j.data["ListType"], ["DateString"] = j.data["DateString"]}
				end
				ESO_CA_SavedData.SavedLogs[NewLogNumber]["DMGListSkill"] = DamageListOutSkillTable
				
				TargetListTable = {} -- Target List
				for k, j in pairs(TargetList) do
					TargetListTable[k] = {["Damage"] = j.data["Damage"], ["HitCount"] = j.data["HitCount"] , ["CritHitCount"] = j.data["CritHitCount"], ["TargetName"] = j.data["TargetName"], ["FirstTime"] = j.data["FirstTime"] , ["LastTime"] = j.data["LastTime"]}
				end
				ESO_CA_SavedData.SavedLogs[NewLogNumber]["TargetList"] = TargetListTable
				
				ESO_CA_SavedData.SavedLogs[NewLogNumber]["DPSARRAY"] = ESO_CA_DPSARRAY
				
				HealListInTable = {} -- Heal In
				for k, j in pairs(IHealList) do
					HealListInTable[k] = {["SkillIcon"] = j.data["SkillIcon"], ["SkillName"] = j.data["SkillName"], ["Damage"] = j.data["Damage"], ["DamageType"] = j.data["DamageType"], ["HitCount"] = j.data["HitCount"] , ["CritHitCount"] = j.data["CritHitCount"], ["CritDamage"] = j.data["CritDamage"], ["TimeStamp"] = j.data["TimeStamp"], ["TimeString"] = j.data["TimeString"], ["ListType"] = j.data["ListType"], ["DateString"] = j.data["DateString"], ["Source"] = j.data["Source"]}
				end
				ESO_CA_SavedData.SavedLogs[NewLogNumber]["IHealList"] = HealListInTable
				
				HealListOutTable = {} -- Heal Out
				for k, j in pairs(OHealList) do
					HealListOutTable[k] = {["SkillIcon"] = j.data["SkillIcon"], ["SkillName"] = j.data["SkillName"], ["Damage"] = j.data["Damage"], ["DamageType"] = j.data["DamageType"], ["HitCount"] = j.data["HitCount"] , ["CritHitCount"] = j.data["CritHitCount"], ["CritDamage"] = j.data["CritDamage"], ["TimeStamp"] = j.data["TimeStamp"], ["TimeString"] = j.data["TimeString"], ["ListType"] = j.data["ListType"], ["DateString"] = j.data["DateString"], ["Target"] = j.data["Target"]}
				end
				ESO_CA_SavedData.SavedLogs[NewLogNumber]["OHealList"] = HealListOutTable

				HealListOutSkillTable = {} -- Heal Out Skill
				for k, j in pairs(HealListOutSkill) do
					HealListOutSkillTable[k] = {["SkillIcon"] = j.data["SkillIcon"], ["SkillName"] = j.data["SkillName"], ["Damage"] = j.data["Damage"], ["DamageType"] = j.data["DamageType"], ["HitCount"] = j.data["HitCount"] , ["CritHitCount"] = j.data["CritHitCount"], ["CritDamage"] = j.data["CritDamage"], ["TimeStamp"] = j.data["TimeStamp"], ["TimeString"] = j.data["TimeString"], ["ListType"] = j.data["ListType"], ["DateString"] = j.data["DateString"]}
				end
				ESO_CA_SavedData.SavedLogs[NewLogNumber]["HealListSkill"] = HealListOutSkillTable
				
				text = "|c880000CombatAnalytics: |c888866" .. ESO_CA_L_LOGSAVED[ESO_CA_Lang] .. "\n" .. ESO_CA_SavedData.SavedLogs[NewLogNumber]["LogNameU"] .. " - " .. NewLogName
			else
				if(UpdateLog == true)then
					ESO_CA_SavedData.SavedLogs[UpdateLogNum]["LogNameU"] = ESO_CA_HISTNAME:GetText()
					text = "|c880000CombatAnalytics: |c888866" .. ESO_CA_L_LOGUPDATED[ESO_CA_Lang] .. "\n" .. ESO_CA_SavedData.SavedLogs[UpdateLogNum]["LogNameU"] .. " - " .. NewLogName
				else
					text = "|c880000CombatAnalytics: |c888866" .. ESO_CA_L_LOGEXISTS[ESO_CA_Lang] .. "\n" .. ESO_CA_SavedData.SavedLogs[UpdateLogNum]["LogNameU"] .. " - " .. NewLogName
				end
			end
		else
			text = "|c880000CombatAnalytics: |c888866" .. ESO_CA_L_LOGEMPTY[ESO_CA_Lang]
		end
	else
		text = "|c880000CombatAnalytics: |c888866" .. ESO_CA_L_LOGCOMBAT[ESO_CA_Lang]
	end
	ESO_CA_INFOTX:SetText(text)
	ESO_CA_INFO:SetHidden(false)
	ESO_CA_INFO:SetAlpha(1)
	ESO_CA_CURRENTINFOFADE = ESO_CA.Fade(5000,ESO_CA_INFO,1,0)
	--Update the Loaded Logs List
	ESO_CA.RefreshLoadLog(SaveTheLog)
	collectgarbage()
end

--function to Update loadlogs
function ESO_CA.RefreshLoadLog(Scrollog)
	--Update the Loaded Logs List
	ZO_ScrollList_Clear(ESO_CA_SCROLLLOAD)
	for i = 1 , table.getn(ESO_CA_SavedData.SavedLogs) , 1 do
		local LogDate = string.sub(ESO_CA_SavedData.SavedLogs[i]["StartDate"],7,8) .. "-" .. string.sub(ESO_CA_SavedData.SavedLogs[i]["StartDate"],5,6) .. "-" .. string.sub(ESO_CA_SavedData.SavedLogs[i]["StartDate"],1,4)
		local LogTime = ESO_CA_SavedData.SavedLogs[i]["EndTime"]
		local LogName = ""
		if(ESO_CA_SavedData.SavedLogs[i]["LogNameU"] ~= "")then
			LogName = ESO_CA_SavedData.SavedLogs[i]["LogNameU"]
		end
		LoadList[i] = ZO_ScrollList_CreateDataEntry( 1, {Date = LogDate , Time = LogTime, Name = LogName, ID = i})
	end
	ZO_ScrollList_Commit(ESO_CA_SCROLLLOAD)
	if(Scrollog == true)then
		ZO_ScrollList_ScrollAbsolute(ESO_CA_SCROLLLOAD,table.getn(ESO_CA_SavedData.SavedLogs)*20)
	end
	collectgarbage()
end

--function to load a Saved Logfile
function ESO_CA.LOADLOG(LogToLoad,SavedLog)
	local ArrayToLoadFrom = {}
	if(SavedLog == true)then
		ArrayToLoadFrom = ESO_CA_SavedData.SavedLogs[LogToLoad]
	elseif(SavedLog == false)then
		ArrayToLoadFrom = TempLogArray[LogToLoad]
	else
		return
	end
	
	--Refresh the TempLog Text
	local StartYearString = string.sub(ArrayToLoadFrom["EndDate"],1,4)
	local StartMonthString = string.sub(ArrayToLoadFrom["EndDate"],5,6)
	local StartDayString = string.sub(ArrayToLoadFrom["EndDate"],7,8)
	local Date = StartDayString .. "-" .. StartMonthString .. "-" .. StartYearString
	if(ArrayToLoadFrom["LogNameU"] ~= "" and SavedLog == true)then
		ESO_CA_HISTNAME:SetText(ArrayToLoadFrom["LogNameU"])
	else
		ESO_CA_HISTNAME:SetText(Date .. " " .. ArrayToLoadFrom["EndTime"])
	end
	
	--Set the Variables	
	ESO_CA_StartDate = ArrayToLoadFrom["StartDate"]
	ESO_CA_StartTime = ArrayToLoadFrom["StartTime"]
	ESO_CA_EndDate = ArrayToLoadFrom["EndDate"]
	ESO_CA_EndTime = ArrayToLoadFrom["EndTime"]
	ESO_CA_TIMEINCOMBAT = ArrayToLoadFrom["TimeIC"]
	ESO_CA_TIMEUNTILFIGHT = ArrayToLoadFrom["TimeBF"]
	ESO_CA_TIMEINFIGHT = ArrayToLoadFrom["TimeIF"]
	ESO_CA_TIMEAFTERFIGHT = ArrayToLoadFrom["TimeAF"]
	ESO_CA_TOTALDAMAGE = ArrayToLoadFrom["DMGT"]
	ESO_CA_TOTALCRITDAMAGE = ArrayToLoadFrom["DMGC"]
	ESO_CA_TOTALHITS = ArrayToLoadFrom["HITT"]
	ESO_CA_TOTALCRITHITS = ArrayToLoadFrom["HITC"]
	ESO_CA_TOTALHITSHEAL = ArrayToLoadFrom["HITTHEAL"]
	ESO_CA_TOTALCRITHITSHEAL = ArrayToLoadFrom["HITCHEAL"]
	ESO_CA_HIGHESTDAMAGE = ArrayToLoadFrom["HIGHESTDAMAGE"]
	ESO_CA_STARTTIME = ArrayToLoadFrom["STARTTIME"]
	ESO_CA_TOTALHEAL = ArrayToLoadFrom["HEALT"]
	ESO_CA_TOTALCRITHEAL = ArrayToLoadFrom["HEALC"]
	
	--Set the Input for the Listboxes
	ESO_CA_DPSARRAY = ArrayToLoadFrom["DPSARRAY"]
	
	local DLIT = ArrayToLoadFrom["DMGListIn"]
	ZO_ScrollList_Clear(ESO_CA_SCROLLDIN)
	for i = 1 , table.getn(DLIT) , 1 do
		DamageListIn[i] = ZO_ScrollList_CreateDataEntry( 1, {SkillIcon = DLIT[i]["SkillIcon"], SkillName = DLIT[i]["SkillName"], Damage = DLIT[i]["Damage"], DamageType = DLIT[i]["DamageType"], HitCount = DLIT[i]["HitCount"], CritHitCount = DLIT[i]["CritHitCount"], CritDamage = DLIT[i]["CritDamage"], TimeStamp = DLIT[i]["TimeStamp"], TimeString = DLIT[i]["TimeString"], ListType = DLIT[i]["ListType"], DateString = DLIT[i]["DateString"], Source = DLIT[i]["Source"], HitType = DLIT[i]["HitType"]})
	end
	ZO_ScrollList_Commit(ESO_CA_SCROLLDIN)
	
	local DLOT = ArrayToLoadFrom["DMGListOut"]
	ZO_ScrollList_Clear(ESO_CA_SCROLLDOUT)
	for i = 1 , table.getn(DLOT) , 1 do
		DamageListOut[i] = ZO_ScrollList_CreateDataEntry( 1, {SkillIcon = DLOT[i]["SkillIcon"], SkillName = DLOT[i]["SkillName"], Damage = DLOT[i]["Damage"], DamageType = DLOT[i]["DamageType"], HitCount = DLOT[i]["HitCount"], CritHitCount = DLOT[i]["CritHitCount"], CritDamage = DLOT[i]["CritDamage"], TimeStamp = DLOT[i]["TimeStamp"], TimeString = DLOT[i]["TimeString"], ListType = DLOT[i]["ListType"], DateString = DLOT[i]["DateString"], Target = DLOT[i]["Target"]})
	end
	ZO_ScrollList_Commit(ESO_CA_SCROLLDOUT)
	
	local DLST = ArrayToLoadFrom["DMGListSkill"]
	ZO_ScrollList_Clear(ESO_CA_SCROLLDOUTSKILL)
	for i = 1 , table.getn(DLST) , 1 do
		DamageListOutSkill[i] = ZO_ScrollList_CreateDataEntry( 1, {SkillIcon = DLST[i]["SkillIcon"], SkillName = DLST[i]["SkillName"], Damage = DLST[i]["Damage"], DamageType = DLST[i]["DamageType"], HitCount = DLST[i]["HitCount"], CritHitCount = DLST[i]["CritHitCount"], CritDamage = DLST[i]["CritDamage"], TimeStamp = DLST[i]["TimeStamp"], TimeString = DLST[i]["TimeString"], ListType = DLST[i]["ListType"], DateString = DLST[i]["DateString"]})
	end
	ZO_ScrollList_Commit(ESO_CA_SCROLLDOUTSKILL)

	local TART = ArrayToLoadFrom["TargetList"]
	ZO_ScrollList_Clear(ESO_CA_SCROLLTARGET)
	for i = 1 , table.getn(TART) , 1 do
		TargetList[i] = ZO_ScrollList_CreateDataEntry( 1, {Damage = TART[i]["Damage"], HitCount = TART[i]["HitCount"] , CritHitCount = TART[i]["CritHitCount"], TargetName = TART[i]["TargetName"], FirstTime = TART[i]["FirstTime"] , LastTime = TART[i]["LastTime"]})
	end
	ZO_ScrollList_Commit(ESO_CA_SCROLLTARGET)
	
	local HLIT = ArrayToLoadFrom["IHealList"]
	ZO_ScrollList_Clear(ESO_CA_SCROLLIHEAL)
	for i = 1 , table.getn(HLIT) , 1 do
		IHealList[i] = ZO_ScrollList_CreateDataEntry( 1, {SkillIcon = HLIT[i]["SkillIcon"], SkillName = HLIT[i]["SkillName"], Damage = HLIT[i]["Damage"], DamageType = HLIT[i]["DamageType"], HitCount = HLIT[i]["HitCount"], CritHitCount = HLIT[i]["CritHitCount"], CritDamage = HLIT[i]["CritDamage"], TimeStamp = HLIT[i]["TimeStamp"], TimeString = HLIT[i]["TimeString"], ListType = HLIT[i]["ListType"], DateString = HLIT[i]["DateString"], Source = HLIT[i]["Source"]})
	end
	ZO_ScrollList_Commit(ESO_CA_SCROLLIHEAL)
	
	local HLOT = ArrayToLoadFrom["OHealList"]
	ZO_ScrollList_Clear(ESO_CA_SCROLLOHEAL)
	for i = 1 , table.getn(HLOT) , 1 do
		OHealList[i] = ZO_ScrollList_CreateDataEntry( 1, {SkillIcon = HLOT[i]["SkillIcon"], SkillName = HLOT[i]["SkillName"], Damage = HLOT[i]["Damage"], DamageType = HLOT[i]["DamageType"], HitCount = HLOT[i]["HitCount"], CritHitCount = HLOT[i]["CritHitCount"], CritDamage = HLOT[i]["CritDamage"], TimeStamp = HLOT[i]["TimeStamp"], TimeString = HLOT[i]["TimeString"], ListType = HLOT[i]["ListType"], DateString = HLOT[i]["DateString"], Target = HLOT[i]["Target"]})
	end
	ZO_ScrollList_Commit(ESO_CA_SCROLLOHEAL)
	
	local HLST = ArrayToLoadFrom["HealListSkill"]
	ZO_ScrollList_Clear(ESO_CA_SCROLLHOUTSKILL)
	for i = 1 , table.getn(HLST) , 1 do
		HealListOutSkill[i] = ZO_ScrollList_CreateDataEntry( 1, {SkillIcon = HLST[i]["SkillIcon"], SkillName = HLST[i]["SkillName"], Damage = HLST[i]["Damage"], DamageType = HLST[i]["DamageType"], HitCount = HLST[i]["HitCount"], CritHitCount = HLST[i]["CritHitCount"], CritDamage = HLST[i]["CritDamage"], TimeStamp = HLST[i]["TimeStamp"], TimeString = HLST[i]["TimeString"], ListType = HLST[i]["ListType"], DateString = HLST[i]["DateString"]})
	end
	ZO_ScrollList_Commit(ESO_CA_SCROLLHOUTSKILL)
	
	--Set the Time Texts
	local ESO_CA_DISPLAYTIMEINCOMBAT = string.format("%3.2f", ESO_CA_TIMEINCOMBAT / 1000)
	ESO_CA_TIMEICT:SetText(ESO_CA_DISPLAYTIMEINCOMBAT)
	
	local ESO_CA_DISPLAYTIMEUNTILFIGHT = string.format("%3.2f", ESO_CA_TIMEUNTILFIGHT / 1000)
	ESO_CA_TIMEBFT:SetText(ESO_CA_DISPLAYTIMEUNTILFIGHT)

	local ESO_CA_DISPLAYTIMEINFIGHT = string.format("%3.2f", ESO_CA_TIMEINFIGHT / 1000)
	ESO_CA_TIMEIFT:SetText(ESO_CA_DISPLAYTIMEINFIGHT)
	
	local ESO_CA_DISPLAYTIMEAFTERFIGHT = string.format("%3.2f", ESO_CA_TIMEAFTERFIGHT / 1000)
	ESO_CA_TIMEAFT:SetText(ESO_CA_DISPLAYTIMEAFTERFIGHT)
	
	--Set the DPS Texts
	ESO_CA_DPSICT:SetText( string.format("%3.2f", ESO_CA_TOTALDAMAGE / (ESO_CA_TIMEINCOMBAT / 1000)))
	ESO_CA_DPSIFT:SetText( string.format("%3.2f", ESO_CA_TOTALDAMAGE / (ESO_CA_TIMEINFIGHT / 1000)))
	
	--Set the DMG Texts
	ESO_CA_TDMGTT:SetText(ESO_CA_TOTALDAMAGE)
	ESO_CA_TDMGCT:SetText(ESO_CA_TOTALCRITDAMAGE .. "   (" .. zo_round(100/ESO_CA_TOTALDAMAGE*ESO_CA_TOTALCRITDAMAGE) .. "%)")
	ESO_CA_TDMGNT:SetText(ESO_CA_TOTALDAMAGE-ESO_CA_TOTALCRITDAMAGE)
	
	--Set the HIT Texts
	ESO_CA_THITSTOT:SetText(ESO_CA_TOTALHITS)
	ESO_CA_THITSCT:SetText(ESO_CA_TOTALCRITHITS .. "   (" .. zo_round(100/ESO_CA_TOTALHITS*ESO_CA_TOTALCRITHITS) .. "%)")
	ESO_CA_THITSNT:SetText(ESO_CA_TOTALHITS-ESO_CA_TOTALCRITHITS)
	
	--Set the HPS Texts
	ESO_CA_HPSICT:SetText( string.format("%3.2f", ESO_CA_TOTALHEAL / (ESO_CA_TIMEINCOMBAT / 1000)))
	ESO_CA_HPSIFT:SetText( string.format("%3.2f", ESO_CA_TOTALHEAL / (ESO_CA_TIMEINFIGHT / 1000)))
	
	--Set the Total Heal Texts
	ESO_CA_THEALTT:SetText(ESO_CA_TOTALHEAL)
	ESO_CA_THEALCT:SetText(ESO_CA_TOTALCRITHEAL .. "   (" .. zo_round(100/ESO_CA_TOTALHEAL*ESO_CA_TOTALCRITHEAL) .. "%)")
	ESO_CA_THEALNT:SetText(ESO_CA_TOTALHEAL-ESO_CA_TOTALCRITHEAL)
	
	--Update the Statistic if its visible
	if(ESO_CA_CAS:IsHidden() == false)then
		--Refreh the statistic
		ESO_CA.SHOWSTAT()
		--Update the open Graph
		if(ESO_CA_ActiveGraph ~= nil)then
			ESO_CA_ActiveGraph()
		end
	end
	collectgarbage()
end