-- _____                 _           _    ___              _       _   _      
--/  __ \               | |         | |  / _ \            | |     | | (_)     
--| /  \/ ___  _ __ ___ | |__   __ _| |_/ /_\ \_ __   __ _| |_   _| |_ _  ___  ___ 
--| |    / _ \| '_ ` _ \| '_ \ / _` | __|  _  | '_ \ / _` | | | | | __| |/ __|/ __|
--| \__/\ (_) | | | | | | |_) | (_| | |_| | | | | | | (_| | | |_| | |_| | (__ \__ \
-- \____/\___/|_| |_| |_|_.__/ \__,_|\__\_| |_/_| |_|\__,_|_|\__, |\__|_|\___||___/
--                                                            __/ |           
--                                                           |___/
--Copyright by: ESO-EU Dero / @Deryl
--Thx to @Puse for some helpful Thoughts



-- Settings
--Delay for DPS recording
--Reset to default
--bar and total accuracy  (ESO_CA_DmgTypeContWidth)
--number of temp Logs
--Colour selection for Damagetypes
--Tooltip enable / disable

--Shows the Settings for CombatAnalytics
function ESO_CA.InitSettings()
	local SettingsWidth = 500
	local SettingsHeight = 320
	if (ESO_CA_SET == nil) then
				
		--Frame for Settings
		local ESO_CA_SET = WINDOW_MANAGER:CreateTopLevelWindow("ESO_CA_SET")
		ESO_CA_SET:SetDrawLayer(1)
		ESO_CA_SET:SetAnchor(CENTER,GuiRoot,CENTER,0,0)
		ESO_CA_SET:SetDimensions(SettingsWidth+20,SettingsHeight)
		ESO_CA_SET:SetMouseEnabled(true)
		ESO_CA_SET:SetClampedToScreen(true)
		ESO_CA_SET:SetClampedToScreenInsets(-8,-8,6,6)
		ESO_CA_SET:SetMovable(true)
		ESO_CA_SET:SetHidden(true)
		ESO_CA_SET_BG = WINDOW_MANAGER:CreateControlFromVirtual("ESO_CA_SET_BG",ESO_CA_SET,"ESO_CA_DefaultBackdrop")
		
		--Settings Header
		local ESO_CA_SET_HEADER = WINDOW_MANAGER:CreateControl("ESO_CA_SET_HEADER",ESO_CA_SET,CT_LABEL)
		ESO_CA_SET_HEADER:SetText("|c880000" .. ESO_CA.name .. " |rv." .. ESO_CA.version .. " |c888866" .. ESO_CA_L_SETTINGS[ESO_CA_Lang])
		ESO_CA_SET_HEADER:SetFont("ZoFontGame")
		ESO_CA_SET_HEADER:SetAnchor(TOP,ESO_CA_SET,TOP,0,0)
		
		--X-Button to Close the Statistic
		local ESO_CA_SET_BTNCLOSE = WINDOW_MANAGER:CreateControl("ESO_CA_SET_BTNCLOSE",ESO_CA_SET,CT_BUTTON)
		ESO_CA_SET_BTNCLOSE:SetDimensions(20,20)
		ESO_CA_SET_BTNCLOSE:SetHandler("OnClicked",function() ESO_CA_SET:SetHidden(true) end)
		ESO_CA_SET_BTNCLOSE:SetNormalTexture("ESOUI/art/buttons/decline_up.dds")
		ESO_CA_SET_BTNCLOSE:SetMouseOverTexture("ESOUI/art/buttons/decline_over.dds")
		ESO_CA_SET_BTNCLOSE:SetAnchor(TOPRIGHT,ESO_CA_SET,TOPRIGHT,0,0)
		
		--Line00
		local ESO_CA_SET_LINE00 = WINDOW_MANAGER:CreateControl("ESO_CA_SET_LINE00",ESO_CA_SET,CT_TEXTURE)
		ESO_CA_SET_LINE00:SetDimensions(SettingsWidth+20,2)
		ESO_CA_SET_LINE00:SetAnchor(TOPLEFT,ESO_CA_SET,TOPLEFT,0,25)
		ESO_CA_SET_LINE00:SetTexture("/esoui/art/progression/ability_line.dds")
		
		--Language Container
		local ESO_CA_SET_LANGCONT = WINDOW_MANAGER:CreateControl("ESO_CA_SET_LANGCONT",ESO_CA_SET,CT_CONTROL)
		ESO_CA_SET_LANGCONT:SetDimensions(SettingsWidth,85)
		ESO_CA_SET_LANGCONT:SetAnchor(TOPLEFT,ESO_CA_SET_LINE00,TOPLEFT,10,0)
		
		--Language Settings Header
		local ESO_CA_SET_LANGH = WINDOW_MANAGER:CreateControl("ESO_CA_SET_LANGH",ESO_CA_SET_LANGCONT,CT_LABEL)
		ESO_CA_SET_LANGH:SetText("|c880000" .. ESO_CA_L_LANGUAGE[ESO_CA_Lang][1] .. "|r:")
		ESO_CA_SET_LANGH:SetFont("ZoFontTooltipTitle")
		ESO_CA_SET_LANGH:SetAnchor(TOPLEFT,ESO_CA_SET_LANGCONT,TOPLEFT,0,0)

		--Language Settings
		local ESO_CA_SET_LANGTX = WINDOW_MANAGER:CreateControl("ESO_CA_SET_LANGTX",ESO_CA_SET_LANGCONT,CT_LABEL)
		ESO_CA_SET_LANGTX:SetText("|c888866" .. ESO_CA_L_LANGUAGE[ESO_CA_Lang][1] .. "|r:")
		ESO_CA_SET_LANGTX:SetFont("ZoFontGame")
		ESO_CA_SET_LANGTX:SetAnchor(TOPLEFT,ESO_CA_SET_LANGH,BOTTOMLEFT,0,0)
		local ESO_CA_SET_LANGTX2 = WINDOW_MANAGER:CreateControl("ESO_CA_SET_LANGTX2",ESO_CA_SET_LANGCONT,CT_LABEL)
		ESO_CA_SET_LANGTX2:SetText(" (" .. ESO_CA_SavedData.CustomLanguage .. ")")
		ESO_CA_SET_LANGTX2:SetFont("ZoFontGame")
		ESO_CA_SET_LANGTX2:SetAnchor(TOPLEFT,ESO_CA_SET_LANGTX,TOPRIGHT,5,0)
		
		--DE
		local ESO_CA_SET_LANGDE = WINDOW_MANAGER:CreateControl("ESO_CA_SET_LANGDE",ESO_CA_SET_LANGCONT,CT_BUTTON)
		ESO_CA_SET_LANGDE:SetNormalTexture(NormButton[1])
		ESO_CA_SET_LANGDE:SetMouseOverTexture(NormButton[2])
		ESO_CA_SET_LANGDE:SetDimensions(75,20)
		ESO_CA_SET_LANGDE:SetText("|c888866" .. ESO_CA_L_LANGUAGE[ESO_CA_Lang][2])
		ESO_CA_SET_LANGDE:SetFont("ZoFontGame")
		ESO_CA_SET_LANGDE:SetAnchor(TOPLEFT,ESO_CA_SET_LANGTX,TOPLEFT,175,0)
		ESO_CA_SET_LANGDE:SetHandler("OnClicked",function() ESO_CA.SetCustomLanguage("de") end)
		
		--EN
		local ESO_CA_SET_LANGEN = WINDOW_MANAGER:CreateControl("ESO_CA_SET_LANGEN",ESO_CA_SET_LANGCONT,CT_BUTTON)
		ESO_CA_SET_LANGEN:SetNormalTexture(NormButton[1])
		ESO_CA_SET_LANGEN:SetMouseOverTexture(NormButton[2])
		ESO_CA_SET_LANGEN:SetDimensions(75,20)
		ESO_CA_SET_LANGEN:SetText("|c888866" .. ESO_CA_L_LANGUAGE[ESO_CA_Lang][3])
		ESO_CA_SET_LANGEN:SetFont("ZoFontGame")
		ESO_CA_SET_LANGEN:SetAnchor(TOPLEFT,ESO_CA_SET_LANGDE,TOPRIGHT,5,0)
		ESO_CA_SET_LANGEN:SetHandler("OnClicked",function() ESO_CA.SetCustomLanguage("en") end)
		
		--FR
		local ESO_CA_SET_LANGFR = WINDOW_MANAGER:CreateControl("ESO_CA_SET_LANGFR",ESO_CA_SET_LANGCONT,CT_BUTTON)
		ESO_CA_SET_LANGFR:SetNormalTexture(NormButton[1])
		ESO_CA_SET_LANGFR:SetMouseOverTexture(NormButton[2])
		ESO_CA_SET_LANGFR:SetDimensions(75,20)
		ESO_CA_SET_LANGFR:SetText("|c888866" .. ESO_CA_L_LANGUAGE[ESO_CA_Lang][4])
		ESO_CA_SET_LANGFR:SetFont("ZoFontGame")
		ESO_CA_SET_LANGFR:SetAnchor(TOPLEFT,ESO_CA_SET_LANGEN,TOPRIGHT,5,0)
		ESO_CA_SET_LANGFR:SetHandler("OnClicked",function() log("Sorry, there is currently no French translation.\nI'm working on it!") end)
		
		--AS CLIENT
		local ESO_CA_SET_LANGCL = WINDOW_MANAGER:CreateControl("ESO_CA_SET_LANGCL",ESO_CA_SET_LANGCONT,CT_BUTTON)
		ESO_CA_SET_LANGCL:SetNormalTexture(NormButton[1])
		ESO_CA_SET_LANGCL:SetMouseOverTexture(NormButton[2])
		ESO_CA_SET_LANGCL:SetDimensions(210,20)
		ESO_CA_SET_LANGCL:SetText("|c888866" .. ESO_CA_L_LANGUAGE[ESO_CA_Lang][5] .. " (" .. tostring(GetCVar("language.2")) .. ")")
		ESO_CA_SET_LANGCL:SetFont("ZoFontGame")
		ESO_CA_SET_LANGCL:SetAnchor(TOPLEFT,ESO_CA_SET_LANGDE,BOTTOMLEFT,0,5)
		ESO_CA_SET_LANGCL:SetHandler("OnClicked",function() ESO_CA.SetCustomLanguage("Client") end)
		
		--RELOADUI
		local ESO_CA_SET_RELOAD = WINDOW_MANAGER:CreateControl("ESO_CA_SET_RELOAD",ESO_CA_SET_LANGCONT,CT_BUTTON)
		ESO_CA_SET_RELOAD:SetNormalTexture(ReloadIcon[1])
		ESO_CA_SET_RELOAD:SetMouseOverTexture(ReloadIcon[2])
		ESO_CA_SET_RELOAD:SetDimensions(20,20)
		ESO_CA_SET_RELOAD:SetAnchor(TOPLEFT,ESO_CA_SET_LANGCL,TOPRIGHT,5,0)
		ESO_CA_SET_RELOAD:SetHandler("OnClicked",function() ReloadUI("ingame") end)
		ESO_CA_SET_RELOAD:SetHandler("OnMouseEnter",function() ESO_CA.ShowToolTip(true,ESO_CA_L_RELOAD[ESO_CA_Lang],ESO_CA_SET_RELOAD) end)
		ESO_CA_SET_RELOAD:SetHandler("OnMouseExit",function() ESO_CA_TOOLTIPT:SetHidden(true) end)
		
		--StartUp Container
		local ESO_CA_SET_STARTCONT = WINDOW_MANAGER:CreateControl("ESO_CA_SET_STARTCONT",ESO_CA_SET,CT_CONTROL)
		ESO_CA_SET_STARTCONT:SetDimensions(SettingsWidth,60)
		ESO_CA_SET_STARTCONT:SetAnchor(TOPLEFT,ESO_CA_SET_LANGCONT,BOTTOMLEFT,0,0)
		
		--StartUp Settings Header
		local ESO_CA_SET_STARTH = WINDOW_MANAGER:CreateControl("ESO_CA_SET_STARTH",ESO_CA_SET_STARTCONT,CT_LABEL)
		ESO_CA_SET_STARTH:SetText("|c880000" .. ESO_CA_L_STARTUP[ESO_CA_Lang][1] .. "|r:")
		ESO_CA_SET_STARTH:SetFont("ZoFontTooltipTitle")
		ESO_CA_SET_STARTH:SetAnchor(TOPLEFT,ESO_CA_SET_STARTCONT,TOPLEFT,0,0)

		--StartUp Setting
		local ESO_CA_SET_STARTTX = WINDOW_MANAGER:CreateControl("ESO_CA_SET_STARTTX",ESO_CA_SET_STARTCONT,CT_LABEL)
		ESO_CA_SET_STARTTX:SetText("|c888866" .. ESO_CA_L_STARTUP[ESO_CA_Lang][4] .. "|r:")
		ESO_CA_SET_STARTTX:SetFont("ZoFontGame")
		ESO_CA_SET_STARTTX:SetAnchor(TOPLEFT,ESO_CA_SET_STARTH,BOTTOMLEFT,0,0)
		local ESO_CA_SET_STARTTX2 = WINDOW_MANAGER:CreateControl("ESO_CA_SET_STARTTX2",ESO_CA_SET_STARTCONT,CT_LABEL)		
		ESO_CA_SET_STARTTX2:SetFont("ZoFontGame")
		ESO_CA_SET_STARTTX2:SetAnchor(TOPLEFT,ESO_CA_SET_STARTTX,TOPRIGHT,5,0)
		if(ESO_CA_SavedData.OpenOnStartUp == true)then
			ESO_CA_SET_STARTTX2:SetText("(" .. ESO_CA_L_STARTUP[ESO_CA_Lang][2] .. ")")
		else
			ESO_CA_SET_STARTTX2:SetText("(" .. ESO_CA_L_STARTUP[ESO_CA_Lang][3] .. ")")
		end
		
		--YES
		local ESO_CA_SET_STARTY = WINDOW_MANAGER:CreateControl("ESO_CA_SET_STARTY",ESO_CA_SET_STARTCONT,CT_BUTTON)
		ESO_CA_SET_STARTY:SetNormalTexture(NormButton[1])
		ESO_CA_SET_STARTY:SetMouseOverTexture(NormButton[2])
		ESO_CA_SET_STARTY:SetDimensions(75,20)
		ESO_CA_SET_STARTY:SetText("|c888866" .. ESO_CA_L_STARTUP[ESO_CA_Lang][2])
		ESO_CA_SET_STARTY:SetFont("ZoFontGame")
		ESO_CA_SET_STARTY:SetAnchor(TOPLEFT,ESO_CA_SET_STARTTX,TOPLEFT,175,0)
		ESO_CA_SET_STARTY:SetHandler("OnClicked",function() ESO_CA_SavedData.OpenOnStartUp = true ESO_CA_SET_STARTTX2:SetText("(" .. ESO_CA_L_STARTUP[ESO_CA_Lang][2] .. ")") end)
		
		--NO
		local ESO_CA_SET_STARTN = WINDOW_MANAGER:CreateControl("ESO_CA_SET_STARTN",ESO_CA_SET_STARTCONT,CT_BUTTON)
		ESO_CA_SET_STARTN:SetNormalTexture(NormButton[1])
		ESO_CA_SET_STARTN:SetMouseOverTexture(NormButton[2])
		ESO_CA_SET_STARTN:SetDimensions(75,20)
		ESO_CA_SET_STARTN:SetText("|c888866" .. ESO_CA_L_STARTUP[ESO_CA_Lang][3])
		ESO_CA_SET_STARTN:SetFont("ZoFontGame")
		ESO_CA_SET_STARTN:SetAnchor(TOPLEFT,ESO_CA_SET_STARTY,TOPRIGHT,5,0)
		ESO_CA_SET_STARTN:SetHandler("OnClicked",function() ESO_CA_SavedData.OpenOnStartUp = false ESO_CA_SET_STARTTX2:SetText("(" .. ESO_CA_L_STARTUP[ESO_CA_Lang][3] .. ")") end)
		
		--ToolTip Container
		local ESO_CA_SET_TOOLTCONT = WINDOW_MANAGER:CreateControl("ESO_CA_SET_TOOLTCONT",ESO_CA_SET,CT_CONTROL)
		ESO_CA_SET_TOOLTCONT:SetDimensions(SettingsWidth,60)
		ESO_CA_SET_TOOLTCONT:SetAnchor(TOPLEFT,ESO_CA_SET_STARTCONT,BOTTOMLEFT,0,0)
		
		--ToolTip Settings Header
		local ESO_CA_SET_TOOLTH = WINDOW_MANAGER:CreateControl("ESO_CA_SET_TOOLTH",ESO_CA_SET_TOOLTCONT,CT_LABEL)
		ESO_CA_SET_TOOLTH:SetText("|c880000" .. ESO_CA_L_TOOLTIP[ESO_CA_Lang][1] .. "|r:")
		ESO_CA_SET_TOOLTH:SetFont("ZoFontTooltipTitle")
		ESO_CA_SET_TOOLTH:SetAnchor(TOPLEFT,ESO_CA_SET_TOOLTCONT,TOPLEFT,0,0)

		--ToolTip Setting
		local ESO_CA_SET_TOOLTTX = WINDOW_MANAGER:CreateControl("ESO_CA_SET_TOOLTTX",ESO_CA_SET_TOOLTCONT,CT_LABEL)
		ESO_CA_SET_TOOLTTX:SetText("|c888866" .. ESO_CA_L_TOOLTIP[ESO_CA_Lang][4] .. "|r:")
		ESO_CA_SET_TOOLTTX:SetFont("ZoFontGame")
		ESO_CA_SET_TOOLTTX:SetAnchor(TOPLEFT,ESO_CA_SET_TOOLTH,BOTTOMLEFT,0,0)
		local ESO_CA_SET_TOOLTTX2 = WINDOW_MANAGER:CreateControl("ESO_CA_SET_TOOLTTX2",ESO_CA_SET_TOOLTCONT,CT_LABEL)		
		ESO_CA_SET_TOOLTTX2:SetFont("ZoFontGame")
		ESO_CA_SET_TOOLTTX2:SetAnchor(TOPLEFT,ESO_CA_SET_TOOLTTX,TOPRIGHT,5,0)
		if(ESO_CA_SavedData.ShowToolTip == true)then
			ESO_CA_SET_TOOLTTX2:SetText("(" .. ESO_CA_L_TOOLTIP[ESO_CA_Lang][2] .. ")")
		else
			ESO_CA_SET_TOOLTTX2:SetText("(" .. ESO_CA_L_TOOLTIP[ESO_CA_Lang][3] .. ")")
		end
		
		--YES
		local ESO_CA_SET_TOOLTY = WINDOW_MANAGER:CreateControl("ESO_CA_SET_TOOLTY",ESO_CA_SET_TOOLTCONT,CT_BUTTON)
		ESO_CA_SET_TOOLTY:SetNormalTexture(NormButton[1])
		ESO_CA_SET_TOOLTY:SetMouseOverTexture(NormButton[2])
		ESO_CA_SET_TOOLTY:SetDimensions(75,20)
		ESO_CA_SET_TOOLTY:SetText("|c888866" .. ESO_CA_L_TOOLTIP[ESO_CA_Lang][2])
		ESO_CA_SET_TOOLTY:SetFont("ZoFontGame")
		ESO_CA_SET_TOOLTY:SetAnchor(TOPLEFT,ESO_CA_SET_TOOLTTX,TOPLEFT,175,0)
		ESO_CA_SET_TOOLTY:SetHandler("OnClicked",function() ESO_CA_SavedData.ShowToolTip = true ESO_CA_SET_TOOLTTX2:SetText("(" .. ESO_CA_L_TOOLTIP[ESO_CA_Lang][2] .. ")") end)
		
		--NO
		local ESO_CA_SET_TOOLTN = WINDOW_MANAGER:CreateControl("ESO_CA_SET_TOOLTN",ESO_CA_SET_TOOLTCONT,CT_BUTTON)
		ESO_CA_SET_TOOLTN:SetNormalTexture(NormButton[1])
		ESO_CA_SET_TOOLTN:SetMouseOverTexture(NormButton[2])
		ESO_CA_SET_TOOLTN:SetDimensions(75,20)
		ESO_CA_SET_TOOLTN:SetText("|c888866" .. ESO_CA_L_TOOLTIP[ESO_CA_Lang][3])
		ESO_CA_SET_TOOLTN:SetFont("ZoFontGame")
		ESO_CA_SET_TOOLTN:SetAnchor(TOPLEFT,ESO_CA_SET_TOOLTY,TOPRIGHT,5,0)
		ESO_CA_SET_TOOLTN:SetHandler("OnClicked",function() ESO_CA_SavedData.ShowToolTip = false ESO_CA_SET_TOOLTTX2:SetText("(" .. ESO_CA_L_TOOLTIP[ESO_CA_Lang][3] .. ")") end)
		
		--Colour Container
		local ESO_CA_SET_COLORCONT = WINDOW_MANAGER:CreateControl("ESO_CA_SET_COLORCONT",ESO_CA_SET,CT_CONTROL)
		ESO_CA_SET_COLORCONT:SetDimensions(SettingsWidth,table.getn(ESO_CA_L_DAMAGETYPENAMES[ESO_CA_Lang])*20+60)
		ESO_CA_SET_COLORCONT:SetAnchor(TOPLEFT,ESO_CA_SET_TOOLTCONT,BOTTOMLEFT,0,0)
		
		--Colour Settings Header
		local ESO_CA_SET_COLORH = WINDOW_MANAGER:CreateControl("ESO_CA_SET_COLORH",ESO_CA_SET_COLORCONT,CT_LABEL)
		ESO_CA_SET_COLORH:SetText("|c880000" .. ESO_CA_L_DTYPECOLOR[ESO_CA_Lang] .. "|r:")
		ESO_CA_SET_COLORH:SetFont("ZoFontTooltipTitle")
		ESO_CA_SET_COLORH:SetAnchor(TOPLEFT,ESO_CA_SET_COLORCONT,TOPLEFT,0,0)
		
		local ESO_CA_SET_DTYPETX = {}
		local ESO_CA_SET_DTYPECO = {}
		local ESO_CA_SET_DTYPECO_BG = {}
		for i = 1 , table.getn(ESO_CA_L_DAMAGETYPENAMES[ESO_CA_Lang]) , 1 do
			--Color Setting
			ESO_CA_SET_DTYPETX[i] = WINDOW_MANAGER:CreateControl("ESO_CA_SET_DTYPETX"..i,ESO_CA_SET_COLORCONT,CT_LABEL)
			ESO_CA_SET_DTYPETX[i]:SetText("|c888866" .. ESO_CA_L_DAMAGETYPENAMES[ESO_CA_Lang][i] .. "|r:")
			ESO_CA_SET_DTYPETX[i]:SetFont("ZoFontGame")
			if(i == 1)then
				ESO_CA_SET_DTYPETX[i]:SetAnchor(TOPLEFT,ESO_CA_SET_COLORH,BOTTOMLEFT,0,0)
			else
				ESO_CA_SET_DTYPETX[i]:SetAnchor(TOPLEFT,ESO_CA_SET_DTYPETX[i-1],BOTTOMLEFT,0,0)
			end
			--Colour Texture to Open Selector
			ESO_CA_SET_DTYPECO[i] = WINDOW_MANAGER:CreateControl("ESO_CA_SET_DTYPECO"..i,ESO_CA_SET_COLORCONT,CT_TEXTURE)
			ESO_CA_SET_DTYPECO[i]:SetAnchor(LEFT,ESO_CA_SET_DTYPETX[i],LEFT,175,0)
			ESO_CA_SET_DTYPECO[i]:SetDimensions(100,20)
			ESO_CA_SET_DTYPECO[i]:SetMouseEnabled(true)
			ESO_CA_SET_DTYPECO[i]:SetColor(DamageTypeColors[i-1][1],DamageTypeColors[i-1][2],DamageTypeColors[i-1][3],DamageTypeColors[i-1][4])
			ESO_CA_SET_DTYPECO[i]:SetHandler("OnMouseUp",function(self1)
				ESO_CA_SET_COLORSELCS:SetText(ESO_CA_SET_DTYPETX[i]:GetText())
				ESO_CA_SET_COLORSEL:SetHandler("OnColorSelected",function(self2,r,g,b)
					self1:SetColor(r,g,b,1)
					ESO_CA_SET_COLORSELET:SetColor(r,g,b,1)
					ESO_CA_SavedData.DmgTypeColors[i] = {r,g,b,1}
					ESO_CA_SavedData.DmgTypeColorsH[i] = {r+0.1,g+0.1,b+0.1,1}
					ESO_CA.SetNewDmgTypeCol()
				end)
				local r1,g1,b1,a1 = self1:GetColor()
				ESO_CA_SET_COLORSEL:SetColorAsRGB(r1,g1,b1)
				local h,s,v = ESO_CA_SET_COLORSEL:GetColorAsHSV()
				ESO_CA_SET_COLORSELBRI:SetValue(v)
				ESO_CA_SET_COLORSELET:SetColor(self1:GetColor())
				ESO_CA_SET_COLORSEL:SetHidden(false)
			end)
			ESO_CA_SET_DTYPECO_BG[i] = WINDOW_MANAGER:CreateControlFromVirtual("ESO_CA_SET_DTYPECO_BG"..i,ESO_CA_SET_DTYPECO[i],"ESO_CA_DefaultBackdrop")
		end

		--Color Selector
		local ESO_CA_SET_COLORSEL = WINDOW_MANAGER:CreateControl("ESO_CA_SET_COLORSEL",ESO_CA_SET_COLORCONT,CT_COLORSELECT)
		ESO_CA_SET_COLORSEL:SetDimensions(200,200)
		ESO_CA_SET_COLORSEL:SetMouseEnabled(true)
		ESO_CA_SET_COLORSEL:SetAnchor(RIGHT,ESO_CA_SET_COLORCONT,RIGHT,0,0)
		--ESO_CA_SET_COLORSEL:SetHandler("OnColorSelected",function(self,r,g,b) ESO_CA_SET_COLORTX:SetColor(r,g,b,1) end)
		ESO_CA_SET_COLORSEL:SetHandler("OnMouseUp",function(self)
			--self:SetHidden(true)
			ZO_ScrollList_Commit(ESO_CA_SCROLLDOUT)
			ZO_ScrollList_Commit(ESO_CA_SCROLLDIN)
			ZO_ScrollList_Commit(ESO_CA_SCROLLDOUTSKILL)
			
			ZO_ScrollList_Commit(ESO_CA_SCROLLTARGET)
			
			ZO_ScrollList_Commit(ESO_CA_SCROLLIHEAL)
			ZO_ScrollList_Commit(ESO_CA_SCROLLOHEAL)
			ZO_ScrollList_Commit(ESO_CA_SCROLLHOUTSKILL)
			end)
		ESO_CA_SET_COLORSEL:SetHidden(true)
	
		--Color Setting Current Selection
		local ESO_CA_SET_COLORSELCS = WINDOW_MANAGER:CreateControl("ESO_CA_SET_COLORSELCS",ESO_CA_SET_COLORSEL,CT_LABEL)
		ESO_CA_SET_COLORSELCS:SetText("- " .. ESO_CA_L_EXAMPLETEXT[ESO_CA_Lang] .. " -")
		ESO_CA_SET_COLORSELCS:SetAnchor(BOTTOM,ESO_CA_SET_COLORSEL,TOP,0,-20)
		ESO_CA_SET_COLORSELCS:SetFont("ZoFontGame")
		
		--Color Setting Example Text
		local ESO_CA_SET_COLORSELET = WINDOW_MANAGER:CreateControl("ESO_CA_SET_COLORSELET",ESO_CA_SET_COLORSEL,CT_LABEL)
		ESO_CA_SET_COLORSELET:SetText("- " .. ESO_CA_L_EXAMPLETEXT[ESO_CA_Lang] .. " -")
		ESO_CA_SET_COLORSELET:SetAnchor(TOP,ESO_CA_SET_COLORSELCS,BOTTOM,0,0)
		ESO_CA_SET_COLORSELET:SetFont("ZoFontGame")

		--Brightness Text
		local ESO_CA_SET_COLORSELBR = WINDOW_MANAGER:CreateControl("ESO_CA_SET_COLORSELBR",ESO_CA_SET_COLORSEL,CT_LABEL)
		ESO_CA_SET_COLORSELBR:SetText("|c888866" .. ESO_CA_L_BRIGHTNESS[ESO_CA_Lang] .. "|r:")
		ESO_CA_SET_COLORSELBR:SetAnchor(TOP,ESO_CA_SET_COLORSEL,BOTTOM,0,0)
		ESO_CA_SET_COLORSELBR:SetFont("ZoFontGame")		
		
		--Brightness Slider
		local ESO_CA_SET_COLORSELBRI = WINDOW_MANAGER:CreateControl("ESO_CA_SET_COLORSELBRI",ESO_CA_SET_COLORSEL,CT_SLIDER)
		ESO_CA_SET_COLORSELBRI:SetDimensions(200,20)
		ESO_CA_SET_COLORSELBRI:SetMinMax(0.01,1.1)
		ESO_CA_SET_COLORSELBRI:SetValueStep(0.01)
		ESO_CA_SET_COLORSELBRI:SetOrientation(1)
		ESO_CA_SET_COLORSELBRI:SetEnabled(true)
		ESO_CA_SET_COLORSELBRI:SetMouseEnabled(true)
		ESO_CA_SET_COLORSELBRI:SetAnchor(TOP,ESO_CA_SET_COLORSELBR,BOTTOM,0,0)
		ESO_CA_SET_COLORSELBRI:SetThumbTexture(SliderIcon[1], SliderIcon[1], SliderIcon[2], 10, 40)
		ESO_CA_SET_COLORSELBRI:SetBackgroundMiddleTexture("ESOUI/art/buttons/generic_highlight.dds")
		ESO_CA_SET_COLORSELBRI:SetThumbFlushWithExtents(true)		
		ESO_CA_SET_COLORSELBRI:SetHandler("OnMouseUp",function()
			local a,b,c = ESO_CA_SET_COLORSEL:GetColorAsHSV()
			ESO_CA_SET_COLORSEL:SetColorAsHSV(a,b, ESO_CA_SET_COLORSELBRI:GetValue())
			
			ZO_ScrollList_Commit(ESO_CA_SCROLLDOUT)
			ZO_ScrollList_Commit(ESO_CA_SCROLLDIN)
			ZO_ScrollList_Commit(ESO_CA_SCROLLDOUTSKILL)
			
			ZO_ScrollList_Commit(ESO_CA_SCROLLTARGET)
			
			ZO_ScrollList_Commit(ESO_CA_SCROLLIHEAL)
			ZO_ScrollList_Commit(ESO_CA_SCROLLOHEAL)
			ZO_ScrollList_Commit(ESO_CA_SCROLLHOUTSKILL)
		end)
		
		--Memory Limit Container
		local ESO_CA_SET_MLCONT = WINDOW_MANAGER:CreateControl("ESO_CA_SET_MLCONT",ESO_CA_SET,CT_CONTROL)
		ESO_CA_SET_MLCONT:SetDimensions(SettingsWidth,80)
		ESO_CA_SET_MLCONT:SetAnchor(TOPLEFT,ESO_CA_SET_COLORCONT,BOTTOMLEFT,0,0)
		
		--Memory Limit Settings Header
		local ESO_CA_SET_MLTH = WINDOW_MANAGER:CreateControl("ESO_CA_SET_MLTH",ESO_CA_SET_MLCONT,CT_LABEL)
		ESO_CA_SET_MLTH:SetText("|c880000" .. ESO_CA_L_MEMLIMIT[ESO_CA_Lang][1] .. "|r:")
		ESO_CA_SET_MLTH:SetFont("ZoFontTooltipTitle")
		ESO_CA_SET_MLTH:SetAnchor(TOPLEFT,ESO_CA_SET_MLCONT,TOPLEFT,0,0)

		--Memory Limit Setting
		local ESO_CA_SET_MLTX = WINDOW_MANAGER:CreateControl("ESO_CA_SET_MLTX",ESO_CA_SET_MLCONT,CT_LABEL)
		ESO_CA_SET_MLTX:SetText("|c888866" .. ESO_CA_L_MEMLIMIT[ESO_CA_Lang][2] .. "|r:")
		ESO_CA_SET_MLTX:SetFont("ZoFontGame")
		ESO_CA_SET_MLTX:SetAnchor(TOPLEFT,ESO_CA_SET_MLTH,BOTTOMLEFT,0,0)
		local ESO_CA_SET_MLTX2 = WINDOW_MANAGER:CreateControl("ESO_CA_SET_MLTX2",ESO_CA_SET_MLCONT,CT_LABEL)
		ESO_CA_SET_MLTX2:SetText("(" .. tostring(GetCVar("LuaMemoryLimitMB")) .. " MB)")
		ESO_CA_SET_MLTX2:SetFont("ZoFontGame")
		ESO_CA_SET_MLTX2:SetAnchor(TOPLEFT,ESO_CA_SET_MLTX,TOPRIGHT,5,0)
		
		--Memory Limit Input
		local ESO_CA_SET_MLSET_BG = WINDOW_MANAGER:CreateControlFromVirtual("ESO_CA_SET_MLSET_BG",ESO_CA_SET_MLCONT,"ZO_EditBackdrop")
		ESO_CA_SET_MLSET_BG:SetDimensions(100,20)
		ESO_CA_SET_MLSET_BG:SetAnchor(TOPLEFT,ESO_CA_SET_MLTX,TOPLEFT,175,0)
		local ESO_CA_SET_MLSET = WINDOW_MANAGER:CreateControlFromVirtual("ESO_CA_SET_MLSET", ESO_CA_SET_MLSET_BG, "ZO_DefaultEditForBackdrop")
		ESO_CA_SET_MLSET:SetResizeToFitDescendents(false)
		ESO_CA_SET_MLSET:SetMouseEnabled(true)
		ESO_CA_SET_MLSET:SetHandler("OnMouseEnter",function() ESO_CA.ShowToolTip(true,ESO_CA_L_MEMLIMITTT[ESO_CA_Lang],ESO_CA_SET_MLSET) end)
		ESO_CA_SET_MLSET:SetHandler("OnMouseExit",function() ESO_CA_TOOLTIPT:SetHidden(true) end)
		ESO_CA_SET_MLSET:SetFont("ZoFontGame")
		ESO_CA_SET_MLSET:SetScale(0.8)
		ESO_CA_SET_MLSET:SetText(tostring(GetCVar("LuaMemoryLimitMB")))
		
		--Save
		local ESO_CA_SET_MLSAVE = WINDOW_MANAGER:CreateControl("ESO_CA_SET_MLSAVE",ESO_CA_SET_MLCONT,CT_BUTTON)
		ESO_CA_SET_MLSAVE:SetNormalTexture(NormButton[1])
		ESO_CA_SET_MLSAVE:SetMouseOverTexture(NormButton[2])
		ESO_CA_SET_MLSAVE:SetDimensions(100,20)
		ESO_CA_SET_MLSAVE:SetText("|c888866" .. ESO_CA_L_MEMLIMIT[ESO_CA_Lang][3])
		ESO_CA_SET_MLSAVE:SetFont("ZoFontGame")
		ESO_CA_SET_MLSAVE:SetAnchor(TOPLEFT,ESO_CA_SET_MLSET_BG,TOPRIGHT,5,0)
		ESO_CA_SET_MLSAVE:SetHandler("OnClicked",function()
				if(tonumber(ESO_CA_SET_MLSET:GetText()) ~= nil and tonumber(ESO_CA_SET_MLSET:GetText()) >= 64 and tonumber(ESO_CA_SET_MLSET:GetText()) <= 2048)then
					local LB = GetCVar("LuaMemoryLimitMB")
					local NewMemLimit = zo_round(tonumber(ESO_CA_SET_MLSET:GetText()))
					ESO_CA_SavedData["LuaMemoryLimit"] = NewMemLimit
					SetCVar("LuaMemoryLimitMB", NewMemLimit)
					ESO_CA_SET_MLTX2:SetText("("..tostring(GetCVar("LuaMemoryLimitMB")) .. " MB)")
					local text = ESO_CA_L_MEMLCHANGED[ESO_CA_Lang] .. " " .. LB .. "MB -> " .. ESO_CA_SavedData["LuaMemoryLimit"] .. "MB"
					ESO_CA_INFOTX:SetText(text)
					ESO_CA_INFO:SetHidden(false)
					ESO_CA_INFO:SetAlpha(1)
					ESO_CA_CURRENTINFOFADE = ESO_CA.Fade(5000,ESO_CA_INFO,1,0)
					ESO_CA_SET_MLUTX2:SetText("(" .. math.ceil(collectgarbage("count")/1024).." MB)")
					ESO_CA_SET_MLFTX2:SetText("(" .. tonumber(GetCVar("LuaMemoryLimitMB")) - math.ceil(collectgarbage("count")/1024).." MB)")
				else
					local text = ESO_CA_L_MEMLINVALID[ESO_CA_Lang]
					ESO_CA_INFOTX:SetText(text)
					ESO_CA_INFO:SetHidden(false)
					ESO_CA_INFO:SetAlpha(1)
					ESO_CA_CURRENTINFOFADE = ESO_CA.Fade(5000,ESO_CA_INFO,1,0)
				end
			end)
		
		--Memory in Use Text
		local ESO_CA_SET_MLUTX = WINDOW_MANAGER:CreateControl("ESO_CA_SET_MLUTX",ESO_CA_SET_MLCONT,CT_LABEL)
		ESO_CA_SET_MLUTX:SetText("|c888866" .. ESO_CA_L_MEMLIMIT[ESO_CA_Lang][4] .. "|r:")
		ESO_CA_SET_MLUTX:SetFont("ZoFontGame")
		ESO_CA_SET_MLUTX:SetAnchor(TOPLEFT,ESO_CA_SET_MLSET_BG,BOTTOMLEFT,0,0)
		local ESO_CA_SET_MLUTX2 = WINDOW_MANAGER:CreateControl("ESO_CA_SET_MLUTX2",ESO_CA_SET_MLCONT,CT_LABEL)
		ESO_CA_SET_MLUTX2:SetText("(" .. math.ceil(collectgarbage("count")/1024).." MB)")
		ESO_CA_SET_MLUTX2:SetFont("ZoFontGame")
		ESO_CA_SET_MLUTX2:SetAnchor(TOPLEFT,ESO_CA_SET_MLUTX,TOPRIGHT,5,0)
		
		--Free Memory Text
		local ESO_CA_SET_MLFTX = WINDOW_MANAGER:CreateControl("ESO_CA_SET_MLFTX",ESO_CA_SET_MLCONT,CT_LABEL)
		ESO_CA_SET_MLFTX:SetText("|c888866" .. ESO_CA_L_MEMLIMIT[ESO_CA_Lang][5] .. "|r:")
		ESO_CA_SET_MLFTX:SetFont("ZoFontGame")
		ESO_CA_SET_MLFTX:SetAnchor(TOPLEFT,ESO_CA_SET_MLUTX,BOTTOMLEFT,0,0)
		local ESO_CA_SET_MLFTX2 = WINDOW_MANAGER:CreateControl("ESO_CA_SET_MLFTX2",ESO_CA_SET_MLCONT,CT_LABEL)
		ESO_CA_SET_MLFTX2:SetText("(" .. tonumber(GetCVar("LuaMemoryLimitMB")) - math.ceil(collectgarbage("count")/1024).." MB)")
		ESO_CA_SET_MLFTX2:SetFont("ZoFontGame")
		ESO_CA_SET_MLFTX2:SetAnchor(TOPLEFT,ESO_CA_SET_MLFTX,TOPRIGHT,5,0)
		
		ESO_CA_SET:SetHeight(ESO_CA_SET_LANGCONT:GetHeight() + ESO_CA_SET_STARTCONT:GetHeight() + ESO_CA_SET_TOOLTCONT:GetHeight() + ESO_CA_SET_COLORCONT:GetHeight() + ESO_CA_SET_MLCONT:GetHeight() + 50)
	end
	ESO_CA_SET_MLUTX2:SetText("(" .. math.ceil(collectgarbage("count")/1024).." MB)")
	ESO_CA_SET_MLFTX2:SetText("(" .. tonumber(GetCVar("LuaMemoryLimitMB")) - math.ceil(collectgarbage("count")/1024).." MB)")
end

--function to Set Damagetypecolors after selection
function ESO_CA.SetNewDmgTypeCol()
	DamageTypeColors = {[0]={unpack(ESO_CA_SavedData.DmgTypeColors[1])},[1]={unpack(ESO_CA_SavedData.DmgTypeColors[2])},[2]={unpack(ESO_CA_SavedData.DmgTypeColors[3])},[3]={unpack(ESO_CA_SavedData.DmgTypeColors[4])},[4]={unpack(ESO_CA_SavedData.DmgTypeColors[5])},[5]={unpack(ESO_CA_SavedData.DmgTypeColors[6])},[6]={unpack(ESO_CA_SavedData.DmgTypeColors[7])},[7]={unpack(ESO_CA_SavedData.DmgTypeColors[8])},[8]={unpack(ESO_CA_SavedData.DmgTypeColors[9])},[9]={unpack(ESO_CA_SavedData.DmgTypeColors[10])},[10]={unpack(ESO_CA_SavedData.DmgTypeColors[11])},[11]={unpack(ESO_CA_SavedData.DmgTypeColors[12])}}
	DamageTypeColorsH = {[0]={unpack(ESO_CA_SavedData.DmgTypeColorsH[1])},[1]={unpack(ESO_CA_SavedData.DmgTypeColorsH[2])},[2]={unpack(ESO_CA_SavedData.DmgTypeColorsH[3])},[3]={unpack(ESO_CA_SavedData.DmgTypeColorsH[4])},[4]={unpack(ESO_CA_SavedData.DmgTypeColorsH[5])},[5]={unpack(ESO_CA_SavedData.DmgTypeColorsH[6])},[6]={unpack(ESO_CA_SavedData.DmgTypeColorsH[7])},[7]={unpack(ESO_CA_SavedData.DmgTypeColorsH[8])},[8]={unpack(ESO_CA_SavedData.DmgTypeColorsH[9])},[9]={unpack(ESO_CA_SavedData.DmgTypeColorsH[10])},[10]={unpack(ESO_CA_SavedData.DmgTypeColorsH[11])},[11]={unpack(ESO_CA_SavedData.DmgTypeColorsH[12])}}
end

--function to Open the Settings
function ESO_CA.OpenSettings()
	if(ESO_CA_SET:IsHidden() == true)then
		ESO_CA_SET:SetHidden(false)
	else
		ESO_CA_SET:SetHidden(true)
	end
end

--function to set Custom Language
function ESO_CA.SetCustomLanguage(NewLanguage)
	ESO_CA_SavedData.CustomLanguage = NewLanguage
	ESO_CA_SET_LANGTX2:SetText(" (" .. ESO_CA_SavedData.CustomLanguage .. ")")
	ESO_CA.UpdateLanguage()
end