-- _____                 _           _    ___              _       _   _      
--/  __ \               | |         | |  / _ \            | |     | | (_)     
--| /  \/ ___  _ __ ___ | |__   __ _| |_/ /_\ \_ __   __ _| |_   _| |_ _  ___  ___ 
--| |    / _ \| '_ ` _ \| '_ \ / _` | __|  _  | '_ \ / _` | | | | | __| |/ __|/ __|
--| \__/\ (_) | | | | | | |_) | (_| | |_| | | | | | | (_| | | |_| | |_| | (__ \__ \
-- \____/\___/|_| |_| |_|_.__/ \__,_|\__\_| |_/_| |_|\__,_|_|\__, |\__|_|\___||___/
--                                                            __/ |           
--                                                           |___/
--Copyright by: ESO-EU Dero / @Deryl
--Thx to @Puse for some helpful Thoughts

--function to Check for ConfigVersion Updates and edit them if necessary
function ESO_CA.CheckForUpdate()
	if(ESO_CA_SavedData.ConfigVersion == 1 or ESO_CA_SavedData.ConfigVersion == nil)then -- Until 19.08.2014
		ESO_CA_SavedData.ButtonsHeight = 50
		ESO_CA_SavedData.LoadHeight = 75
		ESO_CA_SavedData.HistoryHeight = 25
		ESO_CA_SavedData.TimeHeight = 25
		ESO_CA_SavedData.DPSHeight = 25
		ESO_CA_SavedData.TotalDmgHeight = 25
		ESO_CA_SavedData.TotalHitsHeight = 25
		ESO_CA_SavedData.DmgInHeight = 75
		ESO_CA_SavedData.DmgOutHeight = 75
		ESO_CA_SavedData.DmgSkillHeight = 75
		ESO_CA_SavedData.TargetHeight = 75		
		for i = 1 , table.getn(ESO_CA_SavedData.SavedLogs) , 1 do
			if(ESO_CA_SavedData.SavedLogs[i]["HEALT"] == nil)then
				ESO_CA_SavedData.SavedLogs[i]["HEALT"] = 1
			end
			if(ESO_CA_SavedData.SavedLogs[i]["HEALC"] == nil)then
				ESO_CA_SavedData.SavedLogs[i]["HEALC"] = 1
			end
		end
		--Remove no longer needed saved vars
		ESO_CA_SavedData["MainTransparency"] = nil
		ESO_CA_SavedData["MainTransparencyBG"] = nil
		ESO_CA_SavedData["StatisticTransparency"] = nil
		ESO_CA_SavedData["StatisticTransparencyBG"] = nil
		ESO_CA_SavedData["SkillTransparency"] = nil
		ESO_CA_SavedData["SkillTransparencyBG"] = nil
		--Set the Updated Message
		ESO_CA_SavedData.ConfigVersion = 2
		zo_callLater(function() log(ESO_CA_L_UPDATED[ESO_CA_Lang] .. " 2") end,10000)
		ESO_CA.CheckForUpdate()
	elseif(ESO_CA_SavedData.ConfigVersion == 2)then
		for i = 1 , table.getn(ESO_CA_SavedData.SavedLogs) , 1 do
			if(ESO_CA_SavedData.SavedLogs[i]["IHealList"] == nil)then
				ESO_CA_SavedData.SavedLogs[i]["IHealList"] = {}
			end
			if(ESO_CA_SavedData.SavedLogs[i]["OHealList"] == nil)then
				ESO_CA_SavedData.SavedLogs[i]["OHealList"] = {}
			end
			if(ESO_CA_SavedData.SavedLogs[i]["HealListSkill"] == nil)then
				ESO_CA_SavedData.SavedLogs[i]["HealListSkill"] = {}
			end
		end
	
		ESO_CA_SavedData.ButtonsHeight = 100		
		--Set the Updated Message
		ESO_CA_SavedData.ConfigVersion = 3
		zo_callLater(function() log(ESO_CA_L_UPDATED[ESO_CA_Lang] .. " 3") end,10000)
		ESO_CA.CheckForUpdate()
	elseif(ESO_CA_SavedData.ConfigVersion == 3)then
		ESO_CA_SavedData.ESO_CA_ICONTShowColumns = {{"Icon",true},{"Dmg",true},{"HitType",true},{"Skill",true},{"Source",false},{"Time",true}}
		--Set the Updated Message
		ESO_CA_SavedData.ConfigVersion = 4
		zo_callLater(function() log(ESO_CA_L_UPDATED[ESO_CA_Lang] .. " 3") end,10000)
		ESO_CA.CheckForUpdate()
	elseif(ESO_CA_SavedData.ConfigVersion == 4)then
		ESO_CA.CheckExSettings()
		zo_callLater(function() log(ESO_CA_L_LOADED[ESO_CA_Lang] .. ESO_CA.version) end,10000)
	end
end

--function to check external Settings
function ESO_CA.CheckExSettings()
	--Check if MemoryLimit has changed (may occur after Update)
	if(tonumber(GetCVar("LuaMemoryLimitMB")) < ESO_CA_SavedData["LuaMemoryLimit"] and tonumber(ESO_CA_SavedData["LuaMemoryLimit"]) ~= nil)then
		local LB = GetCVar("LuaMemoryLimitMB")
		SetCVar("LuaMemoryLimitMB", ESO_CA_SavedData["LuaMemoryLimit"])
		zo_callLater(function() log(ESO_CA_L_MEMLCHANGED[ESO_CA_Lang] .. " " .. LB .. "MB -> " .. ESO_CA_SavedData["LuaMemoryLimit"] .. "MB") end,10000)
	end
end